//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				AnalyserDlg.cpp
// Ucel suboru:			definicia triedy CAnalyserDlg - hlavne dialogove okno modulu Analyser
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Soltis / 12.05.2005
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "Analyser.h"
#include "AnalyserDlg.h"
#include "ViditelnostDlg.h"
#include "OkrajeDlg.h"
#include "TabulkaDlg.h"
#include <math.h>
#include <fstream>
#include "memdc.h"
#include ".\analyserdlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString GetFolderPath()
{
	CString strFilePath, strFolderPath;
	// Get program file path
	TCHAR lpFileName[MAX_PATH + 1];
	GetModuleFileName(NULL, lpFileName, MAX_PATH);
	strFilePath = lpFileName;
	//Get program folder
	int nLastIndex = strFilePath.ReverseFind('\\');
	if (nLastIndex != -1)
		strFolderPath = strFilePath.Left(nLastIndex + 1);
	else
		strFolderPath = _T("\\");

	return strFolderPath;
}
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
};


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CAnalyserDlg dialog
CAnalyserDlg::CAnalyserDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnalyserDlg::IDD, pParent)
	, m_nTypKurzora(0)
	, m_inputCnt(0)
{
	// nastavenie pozicii grafov
	m_grHorny.NastavOkraje(35, 265, 70, 735, 265);
	m_grDolny.NastavOkraje(305, 475, 70, 735, 390);

	// nastavenie popisov grafov
	m_grHorny.NastavPopis(CString("x axis [px]"), CString("profile view"), CString("t [s]"));
	m_grDolny.NastavPopis(CString("z axis [px]"), CString("top view"), CString("t [s]"));

	// nastavenie priznakov pre mys
	m_nTypKurzora = NORMAL_K;
	m_bLeftBtnDown = false;

	// nastavenie viditelnosti klbov podla vstupneho suboru
	NacitajViditelnost();

	// Note: LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CAnalyserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnalyserDlg)
	DDX_Control(pDX, IDC_BTN_PLUS, m_btnZoomIn);
	DDX_Control(pDX, IDC_BTN_MINUS, m_btnZoomOut);
	DDX_Control(pDX, IDC_STATIC1, m_pGraf);
	DDX_Control(pDX, IDC_LIST_CHODZE, m_lbChodze);
	DDX_Control(pDX, IDC_CHECK_KURZORY, m_btnKurzory);
	DDX_Control(pDX, IDC_BTN_SIPKA, m_btnMove);
	DDX_Control(pDX, IDC_SURADNICE, m_stSuradnice);
	DDX_Control(pDX, IDC_BTN_PRIDAT, m_btnPridat);
	DDX_Control(pDX, IDC_BTN_PRISPOSOBIT, m_btnPrisposobit);
	DDX_Control(pDX, IDC_BTN_TAB, m_btnZobrazitTab);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAnalyserDlg, CDialog)
	//{{AFX_MSG_MAP(CAnalyserDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SETCURSOR()
	ON_WM_MOUSEMOVE()
	ON_WM_CONTEXTMENU()
	ON_WM_DRAWITEM()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BTN_PLUS, OnBnClickedZoomIn)
	ON_BN_CLICKED(IDC_BTN_MINUS, OnBnClickedZoomOut)
	ON_BN_CLICKED(IDC_BTN_SIPKA, OnBnClickedMove)
	ON_BN_CLICKED(IDC_BTN_PRIDAT, OnBnClickedPridat)
	ON_BN_CLICKED(IDC_BTN_ODOBRAT, OnBnClickedOdobrat)
	ON_BN_CLICKED(IDC_BTN_RESET, OnBnClickedReset)
	ON_BN_CLICKED(IDC_BTN_PRISPOSOBIT, OnBnClickedPrisposobit)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BTN_TAB, OnBnClickedTab)
	ON_BN_CLICKED(IDC_BTN_ZOBRAZOVAT, OnBnClickedZobrazovat)

	ON_COMMAND(ID_CTXMENU2_LAVECOSI, OnContextMenu2Lavecosi)
	ON_COMMAND(ID_CTXMENU2_PRAVECOSI, OnContextMenu2Pravecosi)
	ON_COMMAND(ID_CTXMENU2_LAVEKOLENO, OnContextMenu2Lavekoleno)
	ON_COMMAND(ID_CTXMENU2_PRAVEKOLENO, OnContextMenu2Pravekoleno)
	ON_COMMAND(ID_CTXMENU2_LAVYCLENOK, OnContextMenu2Lavyclenok)
	ON_COMMAND(ID_CTXMENU2_PRAVYCLENOK, OnContextMenu2Pravyclenok)
	ON_COMMAND(ID_CTXMENU2_LAVAPATA, OnContextMenu2Lavapata)
	ON_COMMAND(ID_CTXMENU2_PRAVAPATA, OnContextMenu2Pravapata)
	ON_COMMAND(ID_CTXMENU2_LAVEPRSTY, OnContextMenu2Laveprsty)
	ON_COMMAND(ID_CTXMENU2_PRAVEPRSTY, OnContextMenu2Praveprsty)
	ON_COMMAND(ID_CTXMENU2_UHLOVARYCHLOST1, OnContextMenu2Uhlovarychlost1)
	ON_COMMAND(ID_CTXMENU2_UHLOVARYCHLOST2, OnContextMenu2Uhlovarychlost2)
	ON_COMMAND(ID_CTXMENU2_UHLOVARYCHLOST3, OnContextMenu2Uhlovarychlost3)
	ON_COMMAND(ID_CTXMENU2_UHLOVARYCHLOST4, OnContextMenu2Uhlovarychlost4)

	ON_COMMAND(ID_CTXMENU_LAVECOSI, OnContextMenuLavecosi)
	ON_COMMAND(ID_CTXMENU_PRAVECOSI, OnContextMenuPravecosi)
	ON_COMMAND(ID_CTXMENU_PRAVEKOLENO, OnContextMenuPravekoleno)
	ON_COMMAND(ID_CTXMENU_LAVEKOLENO, OnContextMenuLavekoleno)
	ON_COMMAND(ID_CTXMENU_LAVYCLENOK, OnContextMenuLavyclenok)
	ON_COMMAND(ID_CTXMENU_PRAVYCLENOK, OnContextMenuPravyclenok)
	ON_COMMAND(ID_CTXMENU_LAVAPATA, OnContextMenuLavapata)
	ON_COMMAND(ID_CTXMENU_PRAVAPATA, OnContextMenuPravapata)
	ON_COMMAND(ID_CTXMENU_LAVEPRSTY, OnContextMenuLaveprsty)
	ON_COMMAND(ID_CTXMENU_PRAVEPRSTY, OnContextMenuPraveprsty)
	ON_COMMAND(ID_CTXMENU_UHLOVARYCHLOST1, OnContextMenuUhlovarychlost1)
	ON_COMMAND(ID_CTXMENU_UHLOVARYCHLOST2, OnContextMenuUhlovarychlost2)
	ON_COMMAND(ID_CTXMENU_UHLOVARYCHLOST3, OnContextMenuUhlovarychlost3)
	ON_COMMAND(ID_CTXMENU_UHLOVARYCHLOST4, OnContextMenuUhlovarychlost4)

	ON_LBN_DBLCLK(IDC_LIST_CHODZE, OnLbnDblclkZoznam)
	ON_LBN_SELCHANGE(IDC_LIST_CHODZE, OnLbnSelchangeZoznam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAnalyserDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	
	if (m_inputCnt > 0)
		PridajChodzu(GetFolderPath() + "data_an\\videosqc1.bbd");
	if (m_inputCnt > 1)
		PridajChodzu(GetFolderPath() + "data_an\\videosqc2.bbd");

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// nastavenie obrazkov pre rozne kurzory na tlacitkach
	HICON m_I1 = AfxGetApp()->LoadIcon(IDI_ZOOMIN);
	m_btnZoomIn.SetIcon(m_I1);
	HICON m_I2 = AfxGetApp()->LoadIcon(IDI_ZOOMOUT);
	m_btnZoomOut.SetIcon(m_I2);
	HICON m_I3 = AfxGetApp()->LoadIcon(IDI_ARROW);
	m_btnMove.SetIcon(m_I3);
	m_btnPrisposobit.EnableWindow(false);
	m_btnZobrazitTab.EnableWindow(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CAnalyserDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}


// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CAnalyserDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}


// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CAnalyserDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


////////////////////////////////////////////////////////////
// Funkcie volane pri vykreslovani dialogu
void CAnalyserDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	// pri vykreslovani plochy, na ktorej su vykreslovane grafy
	if (nIDCtl == IDC_BMP) {
		CDC*	pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
		
		CMemDC*	pBufferDC = new CMemDC(pDC);

		CRect	rt = lpDrawItemStruct->rcItem;
		pBufferDC->Rectangle(&rt);

		// vykreslenie osi grafov
		m_grHorny.NakresliOsi(pBufferDC);
		m_grDolny.NakresliOsi(pBufferDC);

		// vykreslenie priebehov (chodzi) do grafov
		if (m_horne_priebehy.size() > 0) 
			VykresliChodze(pBufferDC);

		delete pBufferDC;
	}
}


// vykreslenie vsetkych nacitanych priebehov
void CAnalyserDlg::VykresliChodze(CDC* pDC)
{
	m_horne_priebehy[0].NastavMenovky(pDC);
	m_dolne_priebehy[0].NastavMenovky(pDC);

	for (UINT i = 0; i < m_horne_priebehy.size(); i++) 
		m_horne_priebehy[i].VykresliChodzu(pDC, i);

	for (UINT j = 0; j < m_dolne_priebehy.size(); j++) 
		m_dolne_priebehy[j].VykresliChodzu(pDC, j);
}
// koniec funkcii volanych pri vykreslovani dialogu
////////////////////////////////////////////////////////


////////////////////////////////////////////////////////
// Funkcie pre zmenu kurzoru

// nastavenie kurzora pre priblizovanie do grafov
void CAnalyserDlg::OnBnClickedZoomIn()
{
	m_nTypKurzora = PRIBLIZ_K;
	SendMessage(WM_SETCURSOR);
}


// nastavenie kurzora pre vzdialovanie sa z grafov
void CAnalyserDlg::OnBnClickedZoomOut()
{
	m_nTypKurzora = VZDIAL_K;
	SendMessage(WM_SETCURSOR);
}


// nastavenie kurzora pre posuvanie priebehov v grafe (normalny kurzor)
void CAnalyserDlg::OnBnClickedMove()
{
	m_nTypKurzora = NORMAL_K;
	SendMessage(WM_SETCURSOR);
}


// nastavenie kurzora
BOOL CAnalyserDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	HCURSOR	hCur;
	switch (m_nTypKurzora) {
		case PRIBLIZ_K:
			hCur = AfxGetApp()->LoadCursor(IDC_ZOOMIN);
			break;

		case VZDIAL_K:
			hCur = AfxGetApp()->LoadCursor(IDC_ZOOMOUT);
			break;

		case POSUN_K:
			hCur = AfxGetApp()->LoadCursor(IDC_MOVE);
			break;

		case NORMAL_K:
		default:
			hCur = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
			break;
	}
	::SetCursor(hCur);
	return TRUE;
}
// koniec funkcii pre zmenu kurzoru
/////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
// Funkcie pre vypis suradnic a akcii vyvolavanych pri posune mysi

// pri pohybe mysi
void CAnalyserDlg::OnMouseMove(UINT nFlags, CPoint pt)
{
	PrelozSuradnice(&pt);
	// ak je posuvany stred grafu
	if (m_nTypKurzora == POSUN_K && m_bLeftBtnDown) {
		// nema zmysel vypisovat suradnice
        VypisSuradnice(CString(_T("")), pt);
		// posun stredu grafu 
		UpravGrafPriDrag(pt);
	}
	// ak je nastavovana oblast pre priblizenie do grafu
	else if (m_nTypKurzora == PRIBLIZ_K && m_bLeftBtnDown) {
		// nema zmysel vypisovat suradnice
		VypisSuradnice(CString(_T("")), pt);
		// nakreslenie okrajov pre priblizovanu oblast
		NakresliOkrajePriblizovanejOblasti(pt);
	}
	// suradnice ma zmysel vypisovat len ak je to zapnute,
	// ak je nejaka chodza nacitana v grafoch a je nastavena
	// nejaka chodza v listboxe zobrazovanych chodzi
	else if (m_btnKurzory.GetCheck() && ZistiOznacenuChodzu() != LB_ERR) {
		NakresliKriz(ZistiOznacenuChodzu(), pt);
		NastavSuradnice(ZistiOznacenuChodzu(), pt);
	}
	// inak nema zmysel vypisovat suradnice
	else
		VypisSuradnice(CString(_T("")), pt);
}


// preklad suradnic z klientskych suradnic na suradnice
// plochy, na ktorej su vykreslovane grafy
void CAnalyserDlg::PrelozSuradnice(CPoint* pt)
{
	ClientToScreen(pt);
	GetDlgItem(IDC_BMP)->ScreenToClient(pt);
}


// vypise na obrazovku ku kurzoru mysi zadane suradnice kurzora v grafe
void CAnalyserDlg::VypisSuradnice(CString strSuradnice, CPoint pt)
{
	// posun od kurzoru mysi
	const int POSUN_OKIENKA_X = 25;
	const int POSUN_OKIENKA_Y = 0;
	// rozmery okienka
	const int SIRKA_OKIENKA = 55;
	const int VYSKA_OKIENKA = 40;

	// ak su suradnice "", nema zmysel ich vypisovat
	if (strSuradnice == "")
		m_stSuradnice.SetWindowPos(&CWnd::wndTop, pt.x + POSUN_OKIENKA_X,
			pt.y + POSUN_OKIENKA_Y, SIRKA_OKIENKA, VYSKA_OKIENKA, SWP_HIDEWINDOW);
	// inak su vypisane
	else {
		m_stSuradnice.SetWindowText(strSuradnice);
		//TODO: m_suradnice. nastavit backgroud
		m_stSuradnice.SetWindowPos(&CWnd::wndTop, pt.x + POSUN_OKIENKA_X,
			pt.y + POSUN_OKIENKA_Y, SIRKA_OKIENKA, VYSKA_OKIENKA, SWP_SHOWWINDOW);
		UpdateData(FALSE);
	}
}


// upravenie pozicie vykreslovanych priebehov
// podla posunu mysi pri posuvani stredu v grafe
void CAnalyserDlg::UpravGrafPriDrag(CPoint pt)
{
	CPoint posun(m_ptZoom.x - pt.x, m_ptZoom.y - pt.y);
	m_ptZoom.SetPoint(pt.x, pt.y);

	if (m_grHorny.vGrafe(pt))
		PosunStredVhornomGrafe(posun);
	else if (m_grDolny.vGrafe(pt))
		PosunStredVdolnomGrafe(posun);

	Redraw();
}


void CAnalyserDlg::Redraw()
{
	GetDlgItem(IDC_BMP)->RedrawWindow();
}


// vykreslovanie okienka, ktore sa ma zvacsit
// pri priblizovani sa do grafu
void CAnalyserDlg::NakresliOkrajePriblizovanejOblasti(CPoint pt)
{
	Redraw();
	CDC*	pDC = GetDlgItem(IDC_BMP)->GetDC();
	pDC->MoveTo(m_ptZoom.x, m_ptZoom.y);
	pDC->LineTo(m_ptZoom.x, pt.y);
	pDC->LineTo(pt.x, pt.y);
	pDC->LineTo(pt.x, m_ptZoom.y);
	pDC->LineTo(m_ptZoom.x, m_ptZoom.y);
}


// zistuje oznacenu chodzu v listboxe chodzi
// pre ucel zistovania suradnic
int CAnalyserDlg::ZistiOznacenuChodzu(void)
{
	// ak nie su grafy posunute, mozme pouzit hociktory priebeh pre zistenie suradnic
	if (m_horne_priebehy.size()>0 && GrafyNeposunute())
		return 0;
	// inak pouzijeme nastaveny priebeh
	else if (m_lbChodze.GetCurSel() != LB_ERR) 
		return m_lbChodze.GetCurSel();
	// ak nie je nastaveny ziaden, nevieme ktoreho suradnice treba vypisat
	else
		return LB_ERR;
}


// nastavenie suradnic podla zvolenej chodze a pozicie kurzora
void CAnalyserDlg::NastavSuradnice(int nChodza, CPoint pt)
{
	// ak sa nenachadza kurzor nad ziadnym grafom,
	// nema zmysel suradnice vypisovat
	if (!m_grHorny.vGrafe(pt) && !m_grDolny.vGrafe(pt)) {
		VypisSuradnice(CString(_T("")), pt);
	}
	// kurzor je nad hornym grafom (sledovana suradnica x)
	if (m_grHorny.vGrafe(pt)) {
		CChodza priebeh = m_horne_priebehy[nChodza];
		CString strSuradnice = priebeh.GetSuradnice(pt, CString("x"));
		VypisSuradnice(strSuradnice, pt);
	} 
	// kurzor je nad dolnym grafom (sledovana suradnica z)
	else if (m_grDolny.vGrafe(pt)){
		CChodza priebeh = m_dolne_priebehy[nChodza];
		CString strSuradnice = priebeh.GetSuradnice(pt, CString("z"));
		VypisSuradnice(strSuradnice, pt);
	}
}

//pri vypisovani suradnic sa vytvara v grafe aj kriz,
//ktory ma stred v mieste, kde sa nachadza kurzor
void CAnalyserDlg::NakresliKriz(int nKtory, CPoint pt)
{
	Redraw();
	if (m_grHorny.vGrafe(pt))
		NakresliKrizVhornom(nKtory, pt);
	else if (m_grDolny.vGrafe(pt))
		NakresliKrizVdolnom(nKtory, pt);
}

//nakreslenie krizu v hornom grafe
void CAnalyserDlg::NakresliKrizVhornom(int nKtory, CPoint pt)
{
	CDC*	pDC = GetDlgItem(IDC_BMP)->GetDC();

	pDC->MoveTo(m_grHorny.Okraj(LAVY_O), pt.y);
	pDC->LineTo(m_grHorny.Okraj(PRAVY_O), pt.y);
	pDC->MoveTo(pt.x, m_grHorny.Okraj(HORNY_O));
	pDC->LineTo(pt.x, m_grHorny.Okraj(DOLNY_O));

	pDC->MoveTo(pt.x, m_grDolny.Okraj(HORNY_O));
	pDC->LineTo(pt.x, m_grDolny.Okraj(DOLNY_O));
}

//nakreslenie krizu v hornom grafe
void CAnalyserDlg::NakresliKrizVdolnom(int nKtory, CPoint pt)
{
	CDC*	pDC = GetDlgItem(IDC_BMP)->GetDC();

	pDC->MoveTo(m_grDolny.Okraj(LAVY_O), pt.y);
	pDC->LineTo(m_grDolny.Okraj(PRAVY_O), pt.y);
	pDC->MoveTo(pt.x, m_grDolny.Okraj(HORNY_O));
	pDC->LineTo(pt.x, m_grDolny.Okraj(DOLNY_O));

	pDC->MoveTo(pt.x, m_grHorny.Okraj(HORNY_O));
	pDC->LineTo(pt.x, m_grHorny.Okraj(DOLNY_O));
}


// vracia true, ak su hodnoty okrajov pre vsetky grafy rovnake
bool CAnalyserDlg::GrafyNeposunute(void)
{
	// ak je nacitany len alebo priebehov, nema byt co vzajomne posunute
	if (m_horne_priebehy.size() == 0 || m_horne_priebehy.size() == 1)
		return true;
	// inak nacitanie hodnot okrajov. chodze
	else {
		double fOkraje1[POCET_HODNOT_OKRAJOV], fOkraje2[POCET_HODNOT_OKRAJOV];
		for (int k = 0; k < POCET_HODNOT_OKRAJOV; k++) {
			fOkraje1[k]= m_horne_priebehy[0].HodnotaOkraju(k);
			fOkraje2[k]= m_dolne_priebehy[0].HodnotaOkraju(k);
		}
		// porovnanie s ostatnymi chodzami
		for (UINT j = 1; j < m_horne_priebehy.size(); j++)
			for (int i = 0; i < POCET_HODNOT_OKRAJOV; i++) {
				// ak sa hociktore 2 okraje nerovnaju, grafy su posunute
				if (fOkraje1[i] != m_horne_priebehy[j].HodnotaOkraju(i))
					return false;
				if (fOkraje2[i] != m_dolne_priebehy[j].HodnotaOkraju(i))
					return false;
			}
	}
	// ak sa nenasiel ani jeden rozdiel, grafy nie su posunute
	return true;
}


// posunutie stredu v hornom grafe (vyziada si aj posunutie
// stredu na casovej osi v dolnom grafe)
void CAnalyserDlg::PosunStredVhornomGrafe(CPoint ptPosun)
{
	// ak nie je oznacena ziadna chodza, posuvaju sa vsetky priebehy (chodze)
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_dolne_priebehy.size(); i++) {
			m_horne_priebehy[i].Stred(ptPosun);
			m_dolne_priebehy[i].StredLenCas(ptPosun);
		}
	// inak len oznacena chodza
	else {
		m_horne_priebehy[m_lbChodze.GetCurSel()].Stred(ptPosun);
		m_dolne_priebehy[m_lbChodze.GetCurSel()].StredLenCas(ptPosun);
	}
}


// posunutie stredu v dolnom grafe (vyziada si aj posunutie
// stredu na casovej osi v hornom grafe)
void CAnalyserDlg::PosunStredVdolnomGrafe(CPoint ptPosun)
{
	// ak nie je oznacena ziadna chodza, posuvaju sa vsetky priebehy (chodze)
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_dolne_priebehy.size(); i++) {
			m_dolne_priebehy[i].Stred(ptPosun);
			m_horne_priebehy[i].StredLenCas(ptPosun);
		}
	// inak len oznacena chodza
	else {
		m_dolne_priebehy[m_lbChodze.GetCurSel()].Stred(ptPosun);
		m_horne_priebehy[m_lbChodze.GetCurSel()].StredLenCas(ptPosun);
	}
}
// koniec funkcii pre vypis suradnic a akcii vyvolavanych pri posune mysi
///////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////
// Funkcie volane pri poziadavke na vykreslovanie menu

// zavolanie vykreslenia menu pre zadavanie
// viditelnosti pozicii klbov a hodnot UR
void CAnalyserDlg::OnContextMenu(CWnd* pWnd, CPoint pt)
{
	GetDlgItem(IDC_BMP)->ScreenToClient(&pt);
	// viditelnost udajov (pozicii klbov a UR) moze byt v kazdom grafe ina
	if (m_grHorny.vGrafe(pt))
		NastavMenu1(pWnd, pt);
	else if (m_grDolny.vGrafe(pt))
		NastavMenu2(pWnd, pt);
}


// vykreslenie menu s viditelnostami udajov nad hornym grafom
void CAnalyserDlg::NastavMenu1(CWnd* pWnd, CPoint pt)
{
	GetDlgItem(IDC_BMP)->ClientToScreen(&pt);

	CMenu menu;
	menu.LoadMenu(IDR_MAINMENU);
	CMenu* pMenu;
	pMenu = menu.GetSubMenu(0);

	// nastavenie podla aktualnej viditelnosti
	if (m_grHorny.ViditelnostKlbu(L_BEDROVY))
		pMenu->CheckMenuItem(ID_CTXMENU_LAVECOSI, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(L_KOLENO))
		pMenu->CheckMenuItem(ID_CTXMENU_LAVEKOLENO, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(L_CLENOK))
		pMenu->CheckMenuItem(ID_CTXMENU_LAVYCLENOK, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(L_PRSTY))
		pMenu->CheckMenuItem(ID_CTXMENU_LAVEPRSTY, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(L_PATA))
		pMenu->CheckMenuItem(ID_CTXMENU_LAVAPATA, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(P_BEDROVY))
		pMenu->CheckMenuItem(ID_CTXMENU_PRAVECOSI, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(P_KOLENO))
		pMenu->CheckMenuItem(ID_CTXMENU_PRAVEKOLENO, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(P_CLENOK))
		pMenu->CheckMenuItem(ID_CTXMENU_PRAVYCLENOK, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(P_PRSTY))
		pMenu->CheckMenuItem(ID_CTXMENU_PRAVEPRSTY, MF_CHECKED);
	
	if (m_grHorny.ViditelnostKlbu(P_PATA))
		pMenu->CheckMenuItem(ID_CTXMENU_PRAVAPATA, MF_CHECKED);
	
	if (m_grHorny.ViditelnostUR(LUR_KCPR))
		pMenu->CheckMenuItem(ID_CTXMENU_UHLOVARYCHLOST1, MF_CHECKED);

	if (m_grHorny.ViditelnostUR(LUR_KCPA))
		pMenu->CheckMenuItem(ID_CTXMENU_UHLOVARYCHLOST2, MF_CHECKED);
	
	if (m_grHorny.ViditelnostUR(PUR_KCPR))
		pMenu->CheckMenuItem(ID_CTXMENU_UHLOVARYCHLOST3, MF_CHECKED);
	
	if (m_grHorny.ViditelnostUR(PUR_KCPA))
		pMenu->CheckMenuItem(ID_CTXMENU_UHLOVARYCHLOST4, MF_CHECKED);

	pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, pWnd);
}


// vykreslenie menu s viditelnostami udajov nad dolnym grafom
void CAnalyserDlg::NastavMenu2(CWnd* pWnd, CPoint pt)
{
	GetDlgItem(IDC_BMP)->ClientToScreen(&pt);
	
	CMenu menu;
	menu.LoadMenu(IDR_MAINMENU);
	CMenu* pMenu;
	pMenu = menu.GetSubMenu(1);

	// nastavenie podla aktualnej viditelnosti
	if (m_grDolny.ViditelnostKlbu(L_BEDROVY))
		pMenu->CheckMenuItem(ID_CTXMENU2_LAVECOSI, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(L_KOLENO))
		pMenu->CheckMenuItem(ID_CTXMENU2_LAVEKOLENO, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(L_CLENOK))
		pMenu->CheckMenuItem(ID_CTXMENU2_LAVYCLENOK, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(L_PRSTY))
		pMenu->CheckMenuItem(ID_CTXMENU2_LAVEPRSTY, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(L_PATA))
		pMenu->CheckMenuItem(ID_CTXMENU2_LAVAPATA, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(P_BEDROVY))
		pMenu->CheckMenuItem(ID_CTXMENU2_PRAVECOSI, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(P_KOLENO))
		pMenu->CheckMenuItem(ID_CTXMENU2_PRAVEKOLENO, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(P_CLENOK))
		pMenu->CheckMenuItem(ID_CTXMENU2_PRAVYCLENOK, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(P_PRSTY))
		pMenu->CheckMenuItem(ID_CTXMENU2_PRAVEPRSTY, MF_CHECKED);
	
	if (m_grDolny.ViditelnostKlbu(P_PATA))
		pMenu->CheckMenuItem(ID_CTXMENU2_PRAVAPATA, MF_CHECKED);	
	
	if (m_grDolny.ViditelnostUR(LUR_KCPR))
		pMenu->CheckMenuItem(ID_CTXMENU2_UHLOVARYCHLOST1, MF_CHECKED);
	
	if (m_grDolny.ViditelnostUR(LUR_KCPA))
		pMenu->CheckMenuItem(ID_CTXMENU2_UHLOVARYCHLOST2, MF_CHECKED);
	
	if (m_grDolny.ViditelnostUR(PUR_KCPR))
		pMenu->CheckMenuItem(ID_CTXMENU2_UHLOVARYCHLOST3, MF_CHECKED);
	
	if (m_grDolny.ViditelnostUR(PUR_KCPA))
		pMenu->CheckMenuItem(ID_CTXMENU2_UHLOVARYCHLOST4, MF_CHECKED);
	
	pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, pWnd);
}
// koniec funkcii volanych pri poziadavke na vykreslovanie menu
//////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////
// Funkcie volane pri pridavani chodze

// stlacenie "Pridat chodzu"
void CAnalyserDlg::OnBnClickedPridat()
{
	// dialog na zadanie vstupneho suboru s chodzou
	TCHAR szFilters[] = _T("BlueBone Data files (*.bbd)|*.bbd||");
	CFileDialog dlgFileDialog(TRUE, "bbd", NULL, OFN_HIDEREADONLY, szFilters);
  
	if (dlgFileDialog.DoModal() == IDOK)
		PridajChodzu(dlgFileDialog.GetFileName());
}

// vlozi chodzu do zoznamu chodz a aktualizuje obrazovku
void CAnalyserDlg::PridajChodzu(CString strBBD)
{
	m_lbChodze.InsertString(-1, strBBD);
	NacitajBBD(strBBD);
	// vsetky doteraz nacitane grafy su prisposobene pre spolocne vykreslenie
	PrisposobPriebehy(&m_horne_priebehy);
	PrisposobPriebehy(&m_dolne_priebehy);

	// enable/disable tlacitiek v dialogu
	m_btnPrisposobit.EnableWindow(true);
	m_btnZobrazitTab.EnableWindow(true);
	if (m_horne_priebehy.size() >= MAX_POCET_CHODZI)
		m_btnPridat.EnableWindow(false);
	NastavCheckKurzory();
	Redraw();
}

// nacitanie zadaneho vstupneho suboru acFileName
void CAnalyserDlg::NacitajBBD(const char* acFileName)
{
	std::ifstream input(acFileName);

	int FPS;
	input >> FPS;
	int frames_count;
	input >> frames_count;
	int loops_count;
	input >> loops_count;

	// kazdy bod ma 3 suradnice, uchovavane budu tri zoznamy suradnic
	CChodza p0(0, acFileName, FPS);
	CChodza p1(&m_grHorny, acFileName, FPS);
	CChodza p2(&m_grDolny, acFileName, FPS);

	double suradnice[3];
	double minima[3]={500,500,500};
	double maxima[3]={0,0,0};

	// nacitanie hodnot 
	// pocet nacitanych hodnot = frames_count*POCET_KLBOV*3 (suradnice na klb)
	for (int i = 0; i < frames_count; i++)
		for (int j = 0; j < POCET_KLBOV; j++) {
			for (int k = 0; k < 3; k++)
				input >> suradnice[k];
			//ulozenie nacitaneho bodu
			p0.UlozKlb(j, suradnice[0]);	//os x
			p1.UlozKlb(j, suradnice[1]);	//os y
			p2.UlozKlb(j, suradnice[2]);	//os z
		}

	// z nacitanych priebehov treba vypocitat UR
	NastavUR(&p0, &p1, &p2);

	// automaticke nastavenie hodnot okrajov
	//p1.NastavHodnotyOkrajov();
	//p2.NastavHodnotyOkrajov();

	// ulozenie priebehov (suradnica x uz nebude zaujimava)
	m_horne_priebehy.push_back(p1);
	m_dolne_priebehy.push_back(p2);

	input.close();
}


// prisposobenie priebehov ulozenych v zadanom zozname
void CAnalyserDlg::PrisposobPriebehy(std::vector<CChodza>* zoznam)
{
	// nastavenie okrajov vsetkych priebehov tak,
	// aby sa cely priebeh nachadzal medzi hodnotami okrajov
	for (UINT l = 0; l < zoznam->size(); l++)
		zoznam->operator[](l).NastavHodnotyOkrajov();
	
	// ak ma zoznam jeden priebeh, nie je co prisposobovat
	if (zoznam->size()<2) return;

	// najdenie minim a maxim hodnot okrajov
	double fExtremy[POCET_HODNOT_OKRAJOV];
	for (int k = 0; k < POCET_HODNOT_OKRAJOV; k++)
		fExtremy[k]=zoznam->operator[](0).HodnotaOkraju(k);
	NastavenieExtremov(&fExtremy[0], zoznam);
	
	// uprava hodnot okrajov vsetkych priebehov podla najdenych minim a maxim
	for(UINT j = 0; j < zoznam->size(); j++) {
		for (int i = 0; i < POCET_HODNOT_OKRAJOV; i++) 
			zoznam->operator[](j).NastavHodnotyOkrajov(i, fExtremy[i]);
	}
}


// vypocet UR podla zadanych priebehov
void CAnalyserDlg::NastavUR(CChodza* pSurX, CChodza* pSurY, CChodza* pSurZ)
{
	double	fUholY[POCET_UR], fPredchUholY[POCET_UR];
	double	fUholZ[POCET_UR], fPredchUholZ[POCET_UR];
	// prejdenie cez vsetky body priebehov (pre istotu je vzata velkost zoznamu 
	// posledneho klbu poslednej suradnice, ak by posledny frame nebol cely nacitany)
	for(int i = 0; i < pSurZ->VelkostKlbu(POCET_KLBOV - 1); i++){
		// nacitanie 3D suradnic potrebnych bodov pre lavu nohu
		SVertex vtLKoleno(pSurX->BodPriebehuKlbu(L_KOLENO, i), pSurY->BodPriebehuKlbu(L_KOLENO, i), pSurZ->BodPriebehuKlbu(L_KOLENO, i));
		SVertex vtLClenok(pSurX->BodPriebehuKlbu(L_CLENOK, i), pSurY->BodPriebehuKlbu(L_CLENOK, i), pSurZ->BodPriebehuKlbu(L_CLENOK, i));
		SVertex vtLPrsty(pSurX->BodPriebehuKlbu(L_PRSTY, i), pSurY->BodPriebehuKlbu(L_PRSTY, i), pSurZ->BodPriebehuKlbu(L_PRSTY, i));
		SVertex vtLPata(pSurX->BodPriebehuKlbu(L_PATA, i), pSurY->BodPriebehuKlbu(L_PATA, i), pSurZ->BodPriebehuKlbu(L_PATA, i));

		// nacitanie 3D suradnic potrebnych bodov pre pravu nohu
		SVertex vtPKoleno(pSurX->BodPriebehuKlbu(P_KOLENO, i), pSurY->BodPriebehuKlbu(P_KOLENO, i), pSurZ->BodPriebehuKlbu(P_KOLENO, i));
		SVertex vtPClenok(pSurX->BodPriebehuKlbu(P_CLENOK, i), pSurY->BodPriebehuKlbu(P_CLENOK, i), pSurZ->BodPriebehuKlbu(P_CLENOK, i));
		SVertex vtPPrsty(pSurX->BodPriebehuKlbu(P_PRSTY, i), pSurY->BodPriebehuKlbu(P_PRSTY, i), pSurZ->BodPriebehuKlbu(P_PRSTY, i));
		SVertex vtPPata(pSurX->BodPriebehuKlbu(P_PATA, i), pSurY->BodPriebehuKlbu(P_PATA, i), pSurZ->BodPriebehuKlbu(P_PATA, i));	

		// vypocet uhlov medzi vektormi (prsty/pata)-clenok a koleno-clenok
		// na lavej aj pravej nohe a pre os xy
		fUholY[LUR_KCPR] = VypocitajUhol(vtLPrsty.x - vtLClenok.x, vtLPrsty.y - vtLClenok.y, vtLKoleno.x - vtLClenok.x, vtLKoleno.y - vtLClenok.y);
		fUholY[LUR_KCPA] = VypocitajUhol(vtLPata.x - vtLClenok.x, vtLPata.y - vtLClenok.y, vtLKoleno.x - vtLClenok.x, vtLKoleno.y - vtLClenok.y);
		fUholY[PUR_KCPR] = VypocitajUhol(vtPPrsty.x - vtPClenok.x, vtPPrsty.y - vtPClenok.y, vtPKoleno.x - vtPClenok.x, vtPKoleno.y - vtPClenok.y);
		fUholY[PUR_KCPA] = VypocitajUhol(vtPPata.x - vtPClenok.x, vtPPata.y - vtPClenok.y, vtPKoleno.x - vtPClenok.x, vtPKoleno.y - vtPClenok.y);

		// vypocet uhlov medzi vektormi (prsty/pata)-clenok a koleno-clenok
		// na lavej aj pravej nohe a pre os xy
		fUholZ[LUR_KCPR] = VypocitajUhol(vtLPrsty.x - vtLClenok.x, vtLPrsty.z - vtLClenok.z, vtLKoleno.x - vtLClenok.x, vtLKoleno.z - vtLClenok.z);
		fUholZ[LUR_KCPA] = VypocitajUhol(vtLPata.x - vtLClenok.x, vtLPata.z - vtLClenok.z, vtLKoleno.x - vtLClenok.x, vtLKoleno.z - vtLClenok.z);
		fUholZ[PUR_KCPR] = VypocitajUhol(vtPPrsty.x - vtPClenok.x, vtPPrsty.z - vtPClenok.z, vtPKoleno.x - vtPClenok.x, vtPKoleno.z - vtPClenok.z);
		fUholZ[PUR_KCPA] = VypocitajUhol(vtPPata.x - vtPClenok.x, vtPPata.z - vtPClenok.z, vtPKoleno.x - vtPClenok.x, vtPKoleno.z - vtPClenok.z);

		// ak je to prvy bod priebehu, neda sa vypocit UR,
		// lebo neexistuje predchadzajuci uhol
		if (i != 0)
			for (int j = 0; j < POCET_UR; j++) {
				pSurY->UlozUR(j, VypocitajUR(fUholY[j], fPredchUholY[j], double(1.0) / pSurY->GetFPS()));
				pSurZ->UlozUR(j, VypocitajUR(fUholZ[j], fPredchUholZ[j], double(1.0) / pSurZ->GetFPS()));
			}
		// ulozenie aktualnych uhlov pre potrebu vypoctu nasledujucej UR
		for (int j = 0; j < POCET_UR; j++) {
			fPredchUholY[j] = fUholY[j];
			fPredchUholZ[j] = fUholZ[j];
		}
	}
}


// vratenie uhlu v stupnoch medzi dvomi vektormmi zadanymi dvomi suradnicami
double CAnalyserDlg::VypocitajUhol(double fV1sur1, double fV1sur2, double fV2sur1, double fV2sur2)
{
	const double fPI = 3.1415926535897932384626433832795;
	double fCitatel = fV1sur1*fV2sur1 + fV1sur2*fV2sur2;
	double fMenovatel = sqrt(pow(fV1sur1, 2) + pow(fV1sur2, 2)) * sqrt(pow(fV2sur1, 2) + pow(fV2sur2, 2));
	
	if (fMenovatel == 0)
		return 0;
	else
        return double(180 * acos(fCitatel / fMenovatel) / fPI);
}


// nastavenie checkboxu kurzory podla toho, ci je mozne zobrazovat
// suradnice v grafoch; ak su priebehy v grafoch vzajomne posunute,
// nema zmysel ich vypisovat, pretoze nie su jednotne
void CAnalyserDlg::NastavCheckKurzory()
{
	if (GrafyNeposunute())
		m_btnKurzory.EnableWindow(true);
	else if (m_lbChodze.GetCurSel() != LB_ERR)
		m_btnKurzory.EnableWindow(true);
	else
		m_btnKurzory.EnableWindow(false);
}


// najdenie minim a maxim hodnot okrajov v zadanom zozname od pozicie 1 
// (hodnoty okrajov priebehu na 0-tej pozicii su uz v poli extremov)
// hodnoty minim a maxim sa nachadzaju v poli fExtremy
void CAnalyserDlg::NastavenieExtremov(double* fExtremy, std::vector<CChodza>* zoznam)
{
	for (UINT i = 1; i < zoznam->size(); i++) {
		if (fExtremy[HORNY_O] > zoznam->operator[](i).HodnotaOkraju(HORNY_O)) 
			fExtremy[HORNY_O] = zoznam->operator[](i).HodnotaOkraju(HORNY_O);
		
		if (fExtremy[DOLNY_O] < zoznam->operator[](i).HodnotaOkraju(DOLNY_O)) 
			fExtremy[DOLNY_O] = zoznam->operator[](i).HodnotaOkraju(DOLNY_O);
		
		if (fExtremy[LAVY_O] > zoznam->operator[](i).HodnotaOkraju(LAVY_O)) 
			fExtremy[LAVY_O] = zoznam->operator[](i).HodnotaOkraju(LAVY_O);
		
		if (fExtremy[PRAVY_O] < zoznam->operator[](i).HodnotaOkraju(PRAVY_O)) 
			fExtremy[PRAVY_O] = zoznam->operator[](i).HodnotaOkraju(PRAVY_O);
		
		if (fExtremy[HORNY_O_UR] > zoznam->operator[](i).HodnotaOkraju(HORNY_O_UR)) 
			fExtremy[HORNY_O_UR] = zoznam->operator[](i).HodnotaOkraju(HORNY_O_UR);
		
		if (fExtremy[DOLNY_O_UR] < zoznam->operator[](i).HodnotaOkraju(DOLNY_O_UR)) 
			fExtremy[DOLNY_O_UR] = zoznam->operator[](i).HodnotaOkraju(DOLNY_O_UR);
	}
}


// vypocet a ulozenie UR (zmena uhlu v stupnoch/sekundu)
double CAnalyserDlg::VypocitajUR(double fAktUhol, double fPredchUhol, double fCas)
{
	double fZmena = fAktUhol - fPredchUhol;
	// je mozne, ze sa uhol zmenil o 181 stupnov, co moze byt ale iba 1 stupen
	//TODO: treba este otestovat
	while (fZmena >= 180)
		fZmena -= 180;
	while (fZmena <= -180)
		fZmena += 180;
	return
		fZmena/fCas;
}
// koniec funkcii volanych pri pridavani chodze
/////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
// Funkcie volane pri manipulacii s listboxom a tlacitkom RESET
void CAnalyserDlg::OnBnClickedOdobrat()
{
	// len ak je oznacena chodza
	if (m_lbChodze.GetCurSel() != LB_ERR) {
		// vymazanie zo zoznamov
		m_horne_priebehy.erase(m_horne_priebehy.begin() + m_lbChodze.GetCurSel());
		m_dolne_priebehy.erase(m_dolne_priebehy.begin() + m_lbChodze.GetCurSel());
		
		// naplnenie listboxu zobrazovanych chodzi
		m_lbChodze.ResetContent();
		for (UINT i = 0; i < m_horne_priebehy.size(); i++) 
			m_lbChodze.InsertString(-1, m_horne_priebehy[i].GetMeno());

		// vsetky doteraz nacitane grafy su prisposobene pre spolocne vykreslenie
		//PrisposobPriebehy(&m_horne_priebehy);
		//PrisposobPriebehy(&m_dolne_priebehy);

		if (m_horne_priebehy.size() == 0) {
			m_btnPrisposobit.EnableWindow(false);
			m_btnZobrazitTab.EnableWindow(false);
		}
		m_btnPridat.EnableWindow(true);
		NastavCheckKurzory();
		Redraw();
	}
	else
		AfxMessageBox(_T("Neoznacili ste ziadnu chodzu!"), MB_OK | MB_ICONEXCLAMATION);
}


// pri doubleclicku sa odznaci zvolena chodza v listboxe
void CAnalyserDlg::OnLbnDblclkZoznam()
{
	m_lbChodze.SetCurSel(-1);
	NastavCheckKurzory();
}


// pri zmene chodze v listboxu je treba skontrolovat
// ci je mozne zobrazovat suradnice
void CAnalyserDlg::OnLbnSelchangeZoznam()
{
	NastavCheckKurzory();
}


// pri stlaceni RESET sa prisposobia vsetky priebehy tak,
// aby sa nachadzali medzi hodnotami okrajov v grafe
void CAnalyserDlg::OnBnClickedReset()
{
	if (m_horne_priebehy.size() == 0)
		return;
	// ak je nacitana iba 1 chodza, staci nastavit okraje
	else if (m_horne_priebehy.size() == 1) {
		m_horne_priebehy[0].NastavHodnotyOkrajov();
		m_dolne_priebehy[0].NastavHodnotyOkrajov();
	}
	// prisposobenie je potrebne len ak su nacitane aspon 2 chodze
	else {
		PrisposobPriebehy(&m_horne_priebehy);
		PrisposobPriebehy(&m_dolne_priebehy);
	}
	NastavCheckKurzory();
	Redraw();
}
// koniec funkcii volanych pri manipulacii s listboxom a tlacitkom RESET
///////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
// Funcie volane pri stlaceni/uvolneni laveho tlacitka mysi

// pri stlaceni mysi sa pravdepodobne manipuluje s grafom
void CAnalyserDlg::OnLButtonDown(UINT nFlags, CPoint pt)
{
	PrelozSuradnice(&pt);
	// posun stredu v grafe
	if (m_nTypKurzora == NORMAL_K) {
		m_nTypKurzora = POSUN_K;
		SendMessage(WM_SETCURSOR);
		m_ptZoom.SetPoint(pt.x, pt.y);
		m_bLeftBtnDown = true;
	}
	// vzdialenie sa z grafu
	else if (m_nTypKurzora == VZDIAL_K){
		if (m_grHorny.vGrafe(pt)) VzdialenieVhornomGrafe(pt);
		if (m_grDolny.vGrafe(pt)) VzdialenieVdolnomGrafe(pt);
	}
	// priblizenie sa do grafu
	else if (m_nTypKurzora == PRIBLIZ_K){
		m_ptZoom.SetPoint(pt.x, pt.y);
		m_bLeftBtnDown = true;
	}
	NastavCheckKurzory();

	CDialog::OnLButtonDown(nFlags, pt);
}


// pri uvolneni mysi treba prisposobit graf podla pozadovanej akcie
void CAnalyserDlg::OnLButtonUp(UINT nFlags, CPoint pt)
{
	PrelozSuradnice(&pt);
	// doteraz sa menil stred grafu
	if (m_nTypKurzora == POSUN_K) {
		m_nTypKurzora = NORMAL_K;
		SendMessage(WM_SETCURSOR);
		m_bLeftBtnDown = false;
	}
	// alebo sa priblizovalo do grafu na zaklade zadania stredu priblizenia
	else if (m_nTypKurzora == PRIBLIZ_K && m_bLeftBtnDown && (pt.x == m_ptZoom.x || pt.y == m_ptZoom.y)) {
		if (m_grHorny.vGrafe(pt)) PriblizenieVhornomGrafe(pt);
		if (m_grDolny.vGrafe(pt)) PriblizenieVdolnomGrafe(pt);
		m_bLeftBtnDown = false;
	}
	// alebo sa priblizovalo do grafu pomocou zadania oblasti
	else if (m_nTypKurzora == PRIBLIZ_K && m_bLeftBtnDown) {
		if (m_grHorny.vGrafe(m_ptZoom) && m_grHorny.vGrafe(pt)) 
			Priblizenie2VhornomGrafe(pt);
		if (m_grDolny.vGrafe(m_ptZoom) && m_grDolny.vGrafe(pt)) 
			Priblizenie2VdolnomGrafe(pt);
		m_bLeftBtnDown = false;
	}
	Redraw();

	CDialog::OnLButtonUp(nFlags, pt);
}


// vzdialenie sa z horneho grafu (z dolneho len na casovej osi)
// podla zadania stredu vzdialenia sa
void CAnalyserDlg::VzdialenieVhornomGrafe(CPoint pt)
{
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_horne_priebehy.size(); i++) {
			m_horne_priebehy[i].Vzdial(pt);
			m_dolne_priebehy[i].VzdialLenCas(pt);
		}
	else {
		m_horne_priebehy[m_lbChodze.GetCurSel()].Vzdial(pt);
		m_dolne_priebehy[m_lbChodze.GetCurSel()].VzdialLenCas(pt);
	}
}


// vzdialenie sa z dolneho grafu (z horneho len na casovej osi)
// podla zadania stredu vzdialenia sa
void CAnalyserDlg::VzdialenieVdolnomGrafe(CPoint pt)
{
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_horne_priebehy.size(); i++) {
			m_dolne_priebehy[i].Vzdial(pt);
			m_horne_priebehy[i].VzdialLenCas(pt);
		}
	else {
		m_dolne_priebehy[m_lbChodze.GetCurSel()].Vzdial(pt);
		m_horne_priebehy[m_lbChodze.GetCurSel()].VzdialLenCas(pt);
	}
}


// priblizenie sa do horneho grafu (do dolneho len na casovej osi)
// podla zadania stredu priblizenia
void CAnalyserDlg::PriblizenieVhornomGrafe(CPoint pt)
{
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_horne_priebehy.size(); i++) {
			m_horne_priebehy[i].Pribliz(pt);
			m_dolne_priebehy[i].PriblizLenCas(pt);
		}
	else {
		m_horne_priebehy[m_lbChodze.GetCurSel()].Pribliz(pt);
		m_dolne_priebehy[m_lbChodze.GetCurSel()].PriblizLenCas(pt);
	}
}


// priblizenie sa do horneho grafu (do dolneho len na casovej osi)
// podla zadania priblizovanej oblasti
void CAnalyserDlg::Priblizenie2VhornomGrafe(CPoint pt)
{
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_horne_priebehy.size(); i++) {
			m_horne_priebehy[i].Pribliz(pt, m_ptZoom);
			m_dolne_priebehy[i].PriblizLenCas(pt, m_ptZoom);
		}
	else {
		m_horne_priebehy[m_lbChodze.GetCurSel()].Pribliz(pt, m_ptZoom);
		m_dolne_priebehy[m_lbChodze.GetCurSel()].PriblizLenCas(pt, m_ptZoom);
	}
}


// priblizenie sa do dolneho grafu (do horneho len na casovej osi)
// podla zadania stredu priblizenia
void CAnalyserDlg::PriblizenieVdolnomGrafe(CPoint pt)
{
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_horne_priebehy.size(); i++) {
			m_dolne_priebehy[i].Pribliz(pt);
			m_horne_priebehy[i].PriblizLenCas(pt);
		}
	else {
		m_dolne_priebehy[m_lbChodze.GetCurSel()].Pribliz(pt);
		m_horne_priebehy[m_lbChodze.GetCurSel()].PriblizLenCas(pt);
	}
}

// priblizenie sa do dolneho grafu (do horneho len na casovej osi)
// podla zadania priblizovanej oblasti
void CAnalyserDlg::Priblizenie2VdolnomGrafe(CPoint pt)
{
	if (m_lbChodze.GetCurSel() == LB_ERR)
		for(UINT i = 0; i < m_horne_priebehy.size(); i++) {
			m_dolne_priebehy[i].Pribliz(pt, m_ptZoom);
			m_horne_priebehy[i].PriblizLenCas(pt, m_ptZoom);
		}
	else {
		m_dolne_priebehy[m_lbChodze.GetCurSel()].Pribliz(pt, m_ptZoom);
		m_horne_priebehy[m_lbChodze.GetCurSel()].PriblizLenCas(pt, m_ptZoom);
	}
}
// koniec funcii volanych pri stlaceni/uvolneni laveho tlacitka mysi
////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////
// Funkcie volane na otvaranie inych dialogovych okien

// otvorenie okna na prisposobenie nacitanych priebehov v grafoch
void CAnalyserDlg::OnBnClickedPrisposobit()
{
	COkrajeDlg dlgOkienko(&m_horne_priebehy, &m_dolne_priebehy);
	if (dlgOkienko.DoModal() == IDOK) {
		NastavCheckKurzory();
		Redraw();
	}
}


// otvorenie okna na nastavenie viditelnosti priebehov v grafoch
void CAnalyserDlg::OnBnClickedZobrazovat()
{
	CViditelnostDlg dlgOkienko(&m_grHorny, &m_grDolny);
	if (dlgOkienko.DoModal() == IDOK)
		Redraw();
}


// otvorenie okna na prehliadanie pozicii klbov a hodnot UR sledovanych chodzi
void CAnalyserDlg::OnBnClickedTab()
{
	CTabulkaDlg dlgOkienko(&m_horne_priebehy, &m_dolne_priebehy);
	dlgOkienko.DoModal();
}
// koniec funcii volanych na otvaranie inych dialogovych okien
///////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
// Funkcie pracujuce s registrami, kde su ulozene viditelnosti priebehov
void CAnalyserDlg::OnBnClickedOk()
{
	UlozViditelnostiDoRegistrov();
	OnOK();
}

// nacitanie viditelnosti udajov z registrov
// 1 ak je udaj viditelny, inak 0
// postupnost udajov je klby v prvom grafe, UR v prvom grafe,
// klby v druhom grafe, UR v druhom grafe,
void CAnalyserDlg::NacitajViditelnost()
{
	CString	strProfile = theApp.GetProfileString(_T("Analyser"), _T("visibility"), _T("1111100000101011111000001010"));

	for (int i = 0; i < POCET_KLBOV; i++) {
		m_grHorny.NastavViditelnostKlbu(i, strProfile.GetAt(i) == '1');
		m_grDolny.NastavViditelnostKlbu(i, strProfile.GetAt(i + POCET_UDAJOV) == '1');
	}

	for (int i = POCET_KLBOV; i < POCET_UDAJOV; i++) {
		m_grHorny.NastavViditelnostUR(i - POCET_KLBOV, strProfile.GetAt(i) == '1');
		m_grDolny.NastavViditelnostUR(i - POCET_KLBOV, strProfile.GetAt(i + POCET_UDAJOV) == '1');
	}
}


// ulozenie viditelnosti udajov do registrov
// 1 ak je udaj viditelny, inak 0
// postupnost udajov je klby v prvom grafe, UR v prvom grafe,
// klby v druhom grafe, UR v druhom grafe,
void CAnalyserDlg::UlozViditelnostiDoRegistrov(void)
{
	CString	strProfile;

    for (int i = 0; i < POCET_KLBOV; i++)
		strProfile.AppendFormat("%d", (int)m_grHorny.ViditelnostKlbu(i));

	for (int i = 0; i < POCET_UR; i++)
		strProfile.AppendFormat("%d", (int)m_grHorny.ViditelnostUR(i));

    for (int i = 0; i < POCET_KLBOV; i++)
		strProfile.AppendFormat("%d", (int)m_grDolny.ViditelnostKlbu(i));

	for (int i = 0; i < POCET_UR; i++)
		strProfile.AppendFormat("%d", (int)m_grDolny.ViditelnostUR(i));

	theApp.WriteProfileString(_T("Analyser"), _T("visibility"), strProfile);
}
// koniec funkcii pracujucich s registrami, kde su ulozene viditelnosti priebehov
////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////
// Funkcie volane pri stlaceni volby v menu
void CAnalyserDlg::OnContextMenuLavecosi()
{
	m_grHorny.ZmenViditelnostKlbu(L_BEDROVY);
	Redraw();
}


void CAnalyserDlg::OnContextMenuPravecosi()
{
	m_grHorny.ZmenViditelnostKlbu(P_BEDROVY);
	Redraw();
}


void CAnalyserDlg::OnContextMenuLavekoleno()
{
	m_grHorny.ZmenViditelnostKlbu(L_KOLENO);
	Redraw();
}


void CAnalyserDlg::OnContextMenuPravekoleno()
{
	m_grHorny.ZmenViditelnostKlbu(P_KOLENO);
	Redraw();
}


void CAnalyserDlg::OnContextMenuLavyclenok()
{
	m_grHorny.ZmenViditelnostKlbu(L_CLENOK);
	Redraw();
}


void CAnalyserDlg::OnContextMenuPravyclenok()
{
	m_grHorny.ZmenViditelnostKlbu(P_CLENOK);
	Redraw();
}


void CAnalyserDlg::OnContextMenuLavapata()
{
	m_grHorny.ZmenViditelnostKlbu(L_PATA);
	Redraw();
}


void CAnalyserDlg::OnContextMenuPravapata()
{
	m_grHorny.ZmenViditelnostKlbu(P_PATA);
	Redraw();
}


void CAnalyserDlg::OnContextMenuLaveprsty()
{
	m_grHorny.ZmenViditelnostKlbu(L_PRSTY);
	Redraw();
}


void CAnalyserDlg::OnContextMenuPraveprsty()
{
	m_grHorny.ZmenViditelnostKlbu(P_PRSTY);
	Redraw();
}


void CAnalyserDlg::OnContextMenuUhlovarychlost1()
{
	m_grHorny.ZmenViditelnostUR(LUR_KCPR);
	Redraw();
}


void CAnalyserDlg::OnContextMenuUhlovarychlost2()
{
	m_grHorny.ZmenViditelnostUR(LUR_KCPA);
	Redraw();
}


void CAnalyserDlg::OnContextMenuUhlovarychlost3()
{
	m_grHorny.ZmenViditelnostUR(PUR_KCPR);
	Redraw();
}


void CAnalyserDlg::OnContextMenuUhlovarychlost4()
{
	m_grHorny.ZmenViditelnostUR(PUR_KCPA);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Lavecosi()
{
	m_grDolny.ZmenViditelnostKlbu(L_BEDROVY);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Pravecosi()
{
	m_grDolny.ZmenViditelnostKlbu(P_BEDROVY);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Lavekoleno()
{
	m_grDolny.ZmenViditelnostKlbu(L_KOLENO);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Pravekoleno()
{
	m_grDolny.ZmenViditelnostKlbu(P_KOLENO);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Lavyclenok()
{
	m_grDolny.ZmenViditelnostKlbu(L_CLENOK);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Pravyclenok()
{
	m_grDolny.ZmenViditelnostKlbu(P_CLENOK);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Lavapata()
{
	m_grDolny.ZmenViditelnostKlbu(L_PATA);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Pravapata()
{
	m_grDolny.ZmenViditelnostKlbu(P_PATA);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Laveprsty()
{
	m_grDolny.ZmenViditelnostKlbu(L_PRSTY);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Praveprsty()
{
	m_grDolny.ZmenViditelnostKlbu(P_PRSTY);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Uhlovarychlost1()
{
	m_grDolny.ZmenViditelnostUR(LUR_KCPR);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Uhlovarychlost2()
{
	m_grDolny.ZmenViditelnostUR(LUR_KCPA);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Uhlovarychlost3()
{
	m_grDolny.ZmenViditelnostUR(PUR_KCPR);
	Redraw();
}


void CAnalyserDlg::OnContextMenu2Uhlovarychlost4()
{
	m_grDolny.ZmenViditelnostUR(PUR_KCPA);
	Redraw();
}


// nastavi nazov suboru, ktory sa ma pri spusteni otvorit (automaticky)
void CAnalyserDlg::SetOpenFilename(CString strVideoCnt)
{
	m_inputCnt = atoi(strVideoCnt);
}
