//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				AnalyserDlg.h
// Ucel suboru:			deklaracia triedy CAnalyserDlg - hlavne dialogove okno modulu Analyser
//						a triedy SVertex - 3 suradnice bodu
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 12.05.2005
//______________________________________________________________________________________________________


#if !defined(AFX_ANALYSERDLG_H__B3132627_5C53_4CD1_A257_5C8D330379F2__INCLUDED_)
#define AFX_ANALYSERDLG_H__B3132627_5C53_4CD1_A257_5C8D330379F2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Chodza.h"
#include "Graf.h"
#include "afxwin.h"
#include <vector>


enum ENUM_KURZORY {
	NORMAL_K,
	PRIBLIZ_K,
	VZDIAL_K,
	POSUN_K
};

#define MAX_POCET_CHODZI 4


// trieda SVertex: 3 suradnice bodu
class SVertex{
public:
	double x, y, z;
	SVertex(double a, double b, double c): x(a), y(b), z(c) {}
};


// hlavne dialogove okno modulu Analyser
class CAnalyserDlg : public CDialog
{
private:
	// horny graf (priestor na vykreslovanie priebehov)
	CGraf	m_grHorny;
	// dolny graf (priestor na vykreslovanie priebehov)
	CGraf	m_grDolny;
	// zoznam priebehov pre horny graf
	// zoznam priebehov pre dolny graf
	std::vector<CChodza> m_horne_priebehy;
	std::vector<CChodza> m_dolne_priebehy;
	// typ kurzora mysi
	int		m_nTypKurzora;
	// pravda, ak je stlacene lave tlacitko mysi
	bool	m_bLeftBtnDown;
	// pomocny bod (pri priblizovani sa do grafu alebo pri posuvani sa v grafe)
	CPoint	m_ptZoom;
	//pocet vstupnych suborov
	int m_inputCnt;
	//CString	m_strFilename;
public:
	CAnalyserDlg(CWnd* pParent = NULL);

	//{{AFX_DATA(CAnalyserDlg)
	enum { IDD = IDD_ANALYSER_DLG };
	CButton		m_btnZoomIn;
	CButton		m_btnZoomOut;
	CStatic		m_pGraf;
	CListBox	m_lbChodze;
	CButton		m_btnKurzory;
	CButton		m_btnMove;
	CButton		m_btnPridat;
	CButton		m_btnPrisposobit;
	CButton		m_btnZobrazitTab;
	CStatic		m_stSuradnice;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAnalyserDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAnalyserDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	// funkcie volane pri vykreslovani dialogu
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	void VykresliChodze(CDC* pDC);

	// funkcie pre zmenu kurzoru
	afx_msg void OnBnClickedZoomIn();
	afx_msg void OnBnClickedZoomOut();
	afx_msg void OnBnClickedMove();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

	// funkcie pre vypis suradnic a akcii vyvolavanych pri posune mysi
	afx_msg void OnMouseMove(UINT nFlags, CPoint pt);
	void PrelozSuradnice(CPoint* pt);
	void VypisSuradnice(CString strSuradnice, CPoint pt);
	void UpravGrafPriDrag(CPoint pt);
	void NakresliOkrajePriblizovanejOblasti(CPoint pt);
	int ZistiOznacenuChodzu(void);
	void NastavSuradnice(int nChodza, CPoint pt);
	void NakresliKriz(int nKtory, CPoint pt);
	void NakresliKrizVhornom(int nKtory, CPoint pt);
	void NakresliKrizVdolnom(int nKtory, CPoint pt);
	bool GrafyNeposunute(void);
	void PosunStredVhornomGrafe(CPoint ptPosun);
	void PosunStredVdolnomGrafe(CPoint ptPosun);

	// funkcie volane pri poziadavke na vykreslovanie menu
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	void NastavMenu1(CWnd* pWnd, CPoint pt);
	void NastavMenu2(CWnd* pWnd, CPoint pt);

	// funkcie volane pri pridavani chodze
	afx_msg void OnBnClickedPridat();
	void NacitajBBD(const char* acFileName);
	void PrisposobPriebehy(std::vector<CChodza>* zoznam);
	void NastavUR(CChodza* pSurX, CChodza* pSurY, CChodza* pSurZ);
	double VypocitajUhol(double fV1sur1, double fV1sur2, double fV2sur1, double fV2sur2);
	void NastavCheckKurzory(void);
	void NastavenieExtremov(double* pPole, std::vector<CChodza>* zoznam);
	double VypocitajUR(double fAktUhol, double fPredchUhol, double fCas);

	// koniec funkcii volanych pri manipulacii s listboxom a tlacitkom RESET
	afx_msg void OnBnClickedOdobrat();
	afx_msg void OnLbnDblclkZoznam();
	afx_msg void OnLbnSelchangeZoznam();
	afx_msg void OnBnClickedReset();

	// funcie volane pri stlaceni/uvolneni laveho tlacitka mysi
	afx_msg void OnLButtonDown(UINT nFlags, CPoint pt);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint pt);
	void PriblizenieVhornomGrafe(CPoint pt);
	void PriblizenieVdolnomGrafe(CPoint pt);
	void Priblizenie2VhornomGrafe(CPoint pt);
	void Priblizenie2VdolnomGrafe(CPoint pt);
	void VzdialenieVhornomGrafe(CPoint pt);
	void VzdialenieVdolnomGrafe(CPoint pt);

	// funcie volane na otvaranie inych dialogovych okien
	afx_msg void OnBnClickedPrisposobit();
	afx_msg void OnBnClickedZobrazovat();

	// funkcie pracujuce s registrami, kde su ulozene viditelnosti priebehov
	afx_msg void OnBnClickedOk();
	void NacitajViditelnost();
	void UlozViditelnostiDoRegistrov();

	// funkcie volane pri stlaceni volby v menu
	afx_msg void OnContextMenu2Pravecosi();
	afx_msg void OnContextMenu2Lavecosi();
	afx_msg void OnContextMenu2Lavekoleno();
	afx_msg void OnContextMenu2Pravekoleno();
	afx_msg void OnContextMenu2Lavyclenok();
	afx_msg void OnContextMenu2Pravyclenok();
	afx_msg void OnContextMenu2Lavapata();
	afx_msg void OnContextMenu2Pravapata();
	afx_msg void OnContextMenu2Laveprsty();
	afx_msg void OnContextMenu2Praveprsty();
	afx_msg void OnContextMenu2Uhlovarychlost1();
	afx_msg void OnContextMenu2Uhlovarychlost2();
	afx_msg void OnContextMenu2Uhlovarychlost3();
	afx_msg void OnContextMenu2Uhlovarychlost4();
	afx_msg void OnContextMenuLavecosi();
	afx_msg void OnContextMenuPravecosi();
	afx_msg void OnContextMenuPravekoleno();
	afx_msg void OnContextMenuLavekoleno();
	afx_msg void OnContextMenuLavyclenok();
	afx_msg void OnContextMenuPravyclenok();
	afx_msg void OnContextMenuLavapata();
	afx_msg void OnContextMenuPravapata();
	afx_msg void OnContextMenuLaveprsty();
	afx_msg void OnContextMenuPraveprsty();
	afx_msg void OnContextMenuUhlovarychlost1();
	afx_msg void OnContextMenuUhlovarychlost2();
	afx_msg void OnContextMenuUhlovarychlost3();
	afx_msg void OnContextMenuUhlovarychlost4();
	afx_msg void OnBnClickedTab();

	void Redraw();
	// nastavi nazov suboru, ktory sa ma pri spusteni otvorit (automaticky)
	void SetOpenFilename(CString strVideoCnt);
	// vlozi chodzu do zoznamu chodz a aktualizuje obrazovku
	void PridajChodzu(CString strBBD);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ANALYSERDLG_H__B3132627_5C53_4CD1_A257_5C8D330379F2__INCLUDED_)
