//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				Graf.h
// Ucel suboru:			deklaracia triedy CGraf - trieda uchovava informacie (viditelnost priebehehov, 
//						pozicia grafu, popis grafu) o grafe, v ktorom su vykreslovane priebehy hodnot
//						pozicii klbov a hodnot UR
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 5.5.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#pragma once
#include "udaje.h"

// okraje pozicie grafu
#define POCET_OKRAJOV 4	
// rozsirenie okraju okolo grafu 
#define OKRAJ_OKOLO_GRAFU 10
// farby pre vykreslovane priebehy
#define POCET_FARIEB 16
enum ENUM_FARBY {
	CERVENA,
	MODRA,
	HNEDA,
	ZELENA,
	MODRA2,
	BEZOVA,
	FIALOVA,
	ZELENA2,
	RUZOVA,
	ORANZOVA,
	FIALOVA2,
	BELASA,
	RUZOVA2,
	SEDA,
	CIERNA,
	BIELA
};

// okraje grafu
enum ENUM_OKRAJE {
	HORNY_O,
	DOLNY_O,
	LAVY_O,
	PRAVY_O,
	HORNY_O_UR,
	DOLNY_O_UR
};


// trieda CGraf uchovava informacie o grafe, v ktorom su vykreslovane
// priebehy hodnot pozicii klbov a hodnot UR
class CGraf
{
	// viditelnost sledovanych udajov (pozicii klbov a uhlovych rychlosti)
	bool	m_bViditelnost[POCET_UDAJOV];
	// pozicie grafov v ramci prvku dialogoveho okna, 
	// na ktory sa priebehy vykresluju
	int		m_nOkraj[POCET_OKRAJOV];

	int		m_nPozCasOsi;			// pozicia casovej osi
	CString m_strPopisVertOsi;		// popis druhej osi grafu
	CString m_strPopisGrafu;		// popis grafu
	CString m_strPopisHorizOsi;		// popis casovej osi

	// pole farieb pre vykreslovane priebehy
	COLORREF m_crFarba[POCET_FARIEB];
	// nazvy vykreslovanych priebehov
	CString	m_strNazovUdaju[POCET_UDAJOV];

	// nastavenie farieb pre rozne vykreslovane priebehy
	void NaplnFarby(void);
	// nastavenie popisov pre rozne vykreslovane priebehy
	void NastavNazvy(void);

public:
	CGraf(void);
	~CGraf(void);

	// praca s premennymi urcujucimi viditelnost jednotlivych priebehov
	void NastavViditelnost();
	void NastavViditelnostKlbu(int nKlb, bool bVidno);
	void NastavViditelnostUR(int nUR, bool bVidno);
	void ZmenViditelnostKlbu(int nKlb);
	void ZmenViditelnostUR(int nUR);
	bool ViditelnostKlbu(int nKlb);
	bool ViditelnostUR(int nUR);

	// praca s poziciou okrajov grafu a casovou osou grafu
	void NastavOkraj(int nOkraj, int nHodnota);
	void NastavOkraje(int nHorny, int nDolny, int nLavy, int nPravy, int nOs);
	int Okraj(int nOkraj);
	int GetOs();

	// nastavenie popisu osi grafu a nazvu grafu
	void NastavPopis(CString str1, CString str2, CString str3);
	// vykreslenie osi grafu, ich popisu a nazvu
	void NakresliOsi(CDC* pDC);

	// zistuje, ci sa zadany bod nachadza nad oblastou grafu
	bool vGrafe(CPoint pt);

	// ziskanie clenskych premennych
	COLORREF Farba(int nFarba);
	CString Nazov(int nNazov);
};
