//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				OkrajeDlg.cpp
// Ucel suboru:			definicia triedy COkrajeDlg - dialogove okno, v ktorom pouzivatel zadava
//						hodnoty okrajov grafu pre vykreslovane priebehy
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 5.5.2005
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "Analyser.h"
#include "OkrajeDlg.h"


// COkrajeDlg dialog

IMPLEMENT_DYNAMIC(COkrajeDlg, CDialog)
COkrajeDlg::COkrajeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COkrajeDlg::IDD, pParent)
{
}


COkrajeDlg::COkrajeDlg(std::vector<CChodza>* priebehy1, std::vector<CChodza>* priebehy2)
	: CDialog(COkrajeDlg::IDD)
{
	m_priebehy1 = priebehy1;
	m_priebehy2 = priebehy2;

	//vkladanie ukazovatelov na editboxy dialogu do pola
	int i = 0;
	m_pEditboxy[i] = &m_h1; i++;
	m_pEditboxy[i] = &m_d1; i++;
	m_pEditboxy[i] = &m_l1; i++;
	m_pEditboxy[i] = &m_p1; i++;
	m_pEditboxy[i] = &m_h1_ur; i++;
	m_pEditboxy[i] = &m_d1_ur; i++;
	m_pEditboxy[i] = &m_h2; i++;
	m_pEditboxy[i] = &m_d2; i++;
	m_pEditboxy[i] = &m_l2; i++;
	m_pEditboxy[i] = &m_p2; i++;
	m_pEditboxy[i] = &m_h2_ur; i++;
	m_pEditboxy[i] = &m_d2_ur; i++;
}


COkrajeDlg::~COkrajeDlg()
{
}


void COkrajeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CHODZE, m_lbChodze);
	DDX_Control(pDX, IDC_EDIT1, m_l1);
	DDX_Control(pDX, IDC_EDIT2, m_p1);
	DDX_Control(pDX, IDC_EDIT3, m_h1);
	DDX_Control(pDX, IDC_EDIT4, m_d1);
	DDX_Control(pDX, IDC_EDIT5, m_h1_ur);
	DDX_Control(pDX, IDC_EDIT6, m_d1_ur);
	DDX_Control(pDX, IDC_EDIT8, m_l2);
	DDX_Control(pDX, IDC_EDIT9, m_p2);
	DDX_Control(pDX, IDC_EDIT10, m_h2);
	DDX_Control(pDX, IDC_EDIT11, m_d2);
	DDX_Control(pDX, IDC_EDIT12, m_h2_ur);
	DDX_Control(pDX, IDC_EDIT13, m_d2_ur);
}


// pri inicializacii dialogu treba naplnit listbox zobrazovanymi chodzami,
// nastavit poziciu v listboxe a podla toho naplnit editboxy hodnotami okrajov
BOOL COkrajeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	for (UINT i = 0; i < m_priebehy1->size(); i++) 
		m_lbChodze.InsertString(-1, m_priebehy1->operator[](i).GetMeno());
	
	NacitajHodnoty();
	m_nPozChodze = 0;
	m_lbChodze.SetCurSel(m_nPozChodze);
	NastavEditBoxy();

	// hodnota v editboxoch m_l2 a m_p2 musi byt rovnaka ako v editboxoch m_l1 a m_p1
	// a preto nie je mozne hodnotu tychto editboxov menit (je menena z editboxov m_l1 a m_p1)
	m_l2.EnableWindow(false);
	m_p2.EnableWindow(false);

	return TRUE;
}


BEGIN_MESSAGE_MAP(COkrajeDlg, CDialog)
	ON_LBN_SELCHANGE(IDC_LIST_CHODZE, OnLbnSelchangeList1)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_EN_CHANGE(IDC_EDIT1, OnEnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, OnEnChangeEdit2)
END_MESSAGE_MAP()


// nacitanie hodnot okrajov zo zoznamov zobrazovanych chodzi do pomocneho pola
void COkrajeDlg::NacitajHodnoty()
{
	for (int i = 0; i < m_lbChodze.GetCount(); i++)
		for (int j = 0; j < POCET_HODNOT_OKRAJOV; j++) {
			m_fHodnoty[2*POCET_HODNOT_OKRAJOV*i + j] =
				m_priebehy1->operator[](i).HodnotaOkraju(j);

			m_fHodnoty[2*POCET_HODNOT_OKRAJOV*i + POCET_HODNOT_OKRAJOV + j] =
				m_priebehy2->operator[](i).HodnotaOkraju(j);
		}
}


// nastavenie hodnot editboxov podla zadanej chodze zo zoznamu zobrazovanych chodzi
void COkrajeDlg::NastavEditBoxy()
{
	CString strObsah;

	for (int j = 0; j < POCET_HODNOT_OKRAJOV; j++) {
		strObsah.Format("%lf", m_fHodnoty[2*POCET_HODNOT_OKRAJOV * m_lbChodze.GetCurSel() + j]);
		m_pEditboxy[j]->SetWindowText(strObsah);	

		strObsah.Format("%lf", m_fHodnoty[2*POCET_HODNOT_OKRAJOV * m_lbChodze.GetCurSel() + POCET_HODNOT_OKRAJOV + j]);
		m_pEditboxy[POCET_HODNOT_OKRAJOV + j]->SetWindowText(strObsah);	
	}
}


// zapisanie hodnot okrajov z editboxov do pomocneho pola
void COkrajeDlg::ZapisHodnotyDoPola()
{
	CString strHodnota;

	for (int i = 0; i < 2*POCET_HODNOT_OKRAJOV; i++) {
		m_pEditboxy[i]->GetWindowText(strHodnota);
		m_fHodnoty[2*POCET_HODNOT_OKRAJOV*m_nPozChodze + i] = atof(strHodnota);
	}
}


// zapisanie hodnot okrajov z pomocneho pola do zoznamov zobrazovanych chodzi
void COkrajeDlg::ZapisHodnoty() 
{
	for (int i = 0; i < m_lbChodze.GetCount(); i++)
		for (int j = 0; j < POCET_HODNOT_OKRAJOV; j++) {
			m_priebehy1->operator[](i).NastavHodnotyOkrajov(j, m_fHodnoty[2*POCET_HODNOT_OKRAJOV*i + j]);
			m_priebehy2->operator[](i).NastavHodnotyOkrajov(j, m_fHodnoty[2*POCET_HODNOT_OKRAJOV*i + POCET_HODNOT_OKRAJOV + j]);	
		}
}


// pri zmene pozicie v listboxe zobrazujucom chodze treba ulozit
// aktualne hodnoty v editboxoch a naplnit editboxy novymi hodnotami
// podla zvolenej chodze
void COkrajeDlg::OnLbnSelchangeList1()
{
	ZapisHodnotyDoPola();
	NastavEditBoxy();
	m_nPozChodze = m_lbChodze.GetCurSel();
}


// pri zavreti dialogu treba zapisat hodnoty okrajov z pomocneho pola
// do zoznamov zobrazovanych chodzi
void COkrajeDlg::OnBnClickedOk()
{
	ZapisHodnotyDoPola();
	ZapisHodnoty();
	OnOK();
}


// hodnota editboxu m_l2 musi byt rovnaka ako hodnota editboxu m_l1
void COkrajeDlg::OnEnChangeEdit1()
{
	CString strHodnota;
	m_l1.GetWindowText(strHodnota);
	m_l2.SetWindowText(strHodnota);
}


// hodnota editboxu m_p2 musi byt rovnaka ako hodnota editboxu m_p1
void COkrajeDlg::OnEnChangeEdit2()
{
	CString strHodnota;
	m_p1.GetWindowText(strHodnota);
	m_p2.SetWindowText(strHodnota);
}
