//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				OkrajeDlg.h
// Ucel suboru:			deklaracia triedy COkrajeDlg - dialogove okno, v ktorom pouzivatel zadava
//						hodnoty okrajov grafu pre vykreslovane priebehy
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 5.5.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#pragma once

#include "Chodza.h"
#include "afxwin.h"
#include "AnalyserDlg.h"


class COkrajeDlg : public CDialog
{
	DECLARE_DYNAMIC(COkrajeDlg)
	
	// zoznam vykreslovanych priebehov v hornom grafe aplikacie
	std::vector<CChodza>* m_priebehy1;
	// zoznam vykreslovanych priebehov v dolnom grafe aplikacie
	std::vector<CChodza>* m_priebehy2;
	// aktualna pozicia v listboxe zobrazujucom chode
	int		m_nPozChodze;
	// ukazovatele na editboxy budu vlozene do pola, aby sa s nimi lahsie pracovalo
	CEdit*	m_pEditboxy[2*POCET_HODNOT_OKRAJOV];
	// pomocne pole na uchovavanie hodnot okrajov pred zavretim dialogu
	double	m_fHodnoty[2*MAX_POCET_CHODZI*POCET_UDAJOV];

	// pociatocne nastavenie dialogu
	virtual BOOL OnInitDialog();

	// nacitanie hodnot okrajov zo zoznamov do pomocneho pola
	void NacitajHodnoty();
	// nastavenie hodnot okrajov z pomocneho pola do editboxov
	void NastavEditBoxy();				
	// zapisanie hodnot okrajov z editboxov do pomocneho pola
	void ZapisHodnotyDoPola();						
	// zapisanie hodnot okrajov z pomocneho pola do zoznamov
	void ZapisHodnoty();	
		
	// pri zmene pozicie v listboxe zobrazujucom chodze treba ulozit
	// aktualne hodnoty v editboxoch a naplnit editboxy novymi hodnotami
	// podla zvolenej chodze
	afx_msg void OnLbnSelchangeList1();		

	// zavretie dialogu = ulozenie hodnot okrajov z pola
	afx_msg void OnBnClickedOk();			

	// pri zmene editboxov m_l1 a m_p1 je potrebne upravit hodnotu
	// v editboxoch m_l2 a m_p2, kde musia byt hodnoty rovnake, t.j.
	// m_l2 = m_l1, m_p2 = m_p1
	afx_msg void OnEnChangeEdit1();			
	afx_msg void OnEnChangeEdit2();

public:
	COkrajeDlg(CWnd* pParent = NULL);
	COkrajeDlg(std::vector<CChodza>* priebehy1, std::vector<CChodza>* priebehy2);
	virtual ~COkrajeDlg();

// Dialog Data
	enum { IDD = IDD_OKRAJE };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	CListBox	m_lbChodze;
	CEdit m_l1;
	CEdit m_p1;
	CEdit m_h1;
	CEdit m_d1;
	CEdit m_h1_ur;
	CEdit m_d1_ur;
	CEdit m_l2;
	CEdit m_p2;
	CEdit m_h2;
	CEdit m_d2;
	CEdit m_h2_ur;
	CEdit m_d2_ur;
};
