//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				TabulkaDlg.cpp
// Ucel suboru:			definicia triedy CTabulkaDlg - dialogove okno, v ktorom si pouzivatel moze
//						prezerat pozicie klbov a hodnoty UR
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 5.5.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "Analyser.h"
#include "TabulkaDlg.h"


IMPLEMENT_DYNAMIC(CTabulkaDlg, CDialog)
CTabulkaDlg::CTabulkaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTabulkaDlg::IDD, pParent)
{
}


CTabulkaDlg::~CTabulkaDlg()
{
}


void CTabulkaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CHODZE, m_lbChodze);
	DDX_Control(pDX, IDC_LIST_TABULKA, m_ctlSuradnice);
	DDX_Control(pDX, IDC_STATIC1, m_stPs);
	DDX_Control(pDX, IDC_STATIC2, m_stPss);
}


BEGIN_MESSAGE_MAP(CTabulkaDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_LBN_SELCHANGE(IDC_LIST_CHODZE, OnLbnSelchangeList1)
END_MESSAGE_MAP()


CTabulkaDlg::CTabulkaDlg(std::vector<CChodza>* priebehy1, std::vector<CChodza>* priebehy2)
	: CDialog(CTabulkaDlg::IDD)
{
	m_priebehy1 = priebehy1;
	m_priebehy2 = priebehy2;
}


// pociatocne nastavenie dialogu
BOOL CTabulkaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	NastavenieMienStlpcov();
	NaplnZoznamZobrChodzi();
	m_lbChodze.SetCurSel(0);
	Nastav();
	
	return TRUE;
}


// nastavenie min stlpcov (nazvy udajov) v CListCtrl
void CTabulkaDlg::NastavenieMienStlpcov(void)
{
	m_ctlSuradnice.InsertColumn(1, ".bedrov.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(2, ".bedrov.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(3, ".koleno.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(4, ".koleno.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(5, ".lenok.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(6, ".lenok.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(7, ".pta.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(8, ".pta.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(9, ".prsty.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(10, ".prsty.z", LVCFMT_LEFT, 30);

	m_ctlSuradnice.InsertColumn(11, "p.bedrov.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(12, "p.bedrov.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(13, "p.koleno.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(14, "p.koleno.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(15, "p.lenok.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(16, "p.lenok.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(17, "p.pta.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(18, "p.pta.z", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(19, "p.prsty.y", LVCFMT_LEFT, 30);
	m_ctlSuradnice.InsertColumn(20, "p.prsty.z", LVCFMT_LEFT, 30);

	m_ctlSuradnice.InsertColumn(21, "UR-k-c-pr.y", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(22, "UR-k-c-pr.z", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(23, "UR-k-c-pa.y", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(24, "UR-k-c-pa.z", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(25, "pUR-k-c-pr.y", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(26, "pUR-k-c-pr.z", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(27, "pUR-k-c-pa.y", LVCFMT_LEFT, 50);
	m_ctlSuradnice.InsertColumn(28, "pUR-k-c-pa.z", LVCFMT_LEFT, 50);
}


// naplnenie zoznamu zobrazovanych chodzi
void CTabulkaDlg::NaplnZoznamZobrChodzi(void)
{
	for (UINT i = 0; i < m_priebehy1->size(); i++) 
		m_lbChodze.InsertString(-1, m_priebehy1->operator[](i).GetMeno());
}


// pri zmene chodze v zozname zobrazovanych chodzi
// treba prepisat suradnice podla zvolenej chodze
void CTabulkaDlg::OnLbnSelchangeList1()
{
	m_ctlSuradnice.DeleteAllItems();
	NastavNultyFrame();
	NastavOstatneFrame();
}


// nastavenie popiskov a hodnot suradnic pre vsetky frame
void CTabulkaDlg::Nastav(void)
{
	NastavPopisky();
	NastavNultyFrame();
	NastavOstatneFrame();
}


void CTabulkaDlg::NastavPopisky(void)
{
	CString strPomoc;
	strPomoc.Format("Poet snmkov = %d", m_priebehy2->operator[](m_lbChodze.GetCurSel()).VelkostKlbu(POCET_KLBOV - 1));
	m_stPs.SetWindowText(strPomoc);

	strPomoc.Format("Poet snmkov/s = %d", m_priebehy2->operator[](m_lbChodze.GetCurSel()).GetFPS());
	m_stPss.SetWindowText(strPomoc);
}


// nastavenie hodnot suradnic pre nulty frame
void CTabulkaDlg::NastavNultyFrame(void)
{
	int priebeh = m_lbChodze.GetCurSel();
	if (m_priebehy2->operator[](priebeh).VelkostKlbu(POCET_KLBOV - 1) > 0) {
		CString strKlbyY[POCET_KLBOV];
		CString strKlbyZ[POCET_KLBOV];

		for (int j = 0; j < POCET_KLBOV; j++) {
			strKlbyY[j].Format("%.0lf", m_priebehy1->operator[](priebeh).BodPriebehuKlbu(j, 0));
			strKlbyZ[j].Format("%.0lf", m_priebehy2->operator[](priebeh).BodPriebehuKlbu(j, 0));
		}

		InsertRow(&m_ctlSuradnice, 0, 2*POCET_UDAJOV, 
			strKlbyY[L_BEDROVY], strKlbyZ[L_BEDROVY], strKlbyY[L_KOLENO], strKlbyZ[L_KOLENO], 
			strKlbyY[L_CLENOK], strKlbyZ[L_CLENOK], strKlbyY[L_PATA] , strKlbyZ[L_PATA], 
			strKlbyY[L_PRSTY], strKlbyZ[L_PRSTY], 
			strKlbyY[P_BEDROVY], strKlbyZ[P_BEDROVY], strKlbyY[P_KOLENO], strKlbyZ[P_KOLENO], 
			strKlbyY[P_CLENOK], strKlbyZ[P_CLENOK], strKlbyY[P_PATA] , strKlbyZ[P_PATA], 
			strKlbyY[P_PRSTY], strKlbyZ[P_PRSTY],
			// nie su vlozene UR, lebo tie sa pocitaju z rozdielu
			// dvoch po sebe nasledujucich uhlov
			CString("--"), CString("--"), CString("--"), CString("--"), 
			CString("--"), CString("--"), CString("--"), CString("--")
		);
	}
}


void CTabulkaDlg::NastavOstatneFrame(void)
{
	int priebeh = m_lbChodze.GetCurSel();
	for (int i = 1; i < m_priebehy2->operator[](priebeh).VelkostKlbu(POCET_KLBOV - 1); i++) {
		CString strKlbyY[POCET_KLBOV], strKlbyZ[POCET_KLBOV];
		CString strURY[POCET_UR], strURZ[POCET_UR];

		for (int j = 0; j < POCET_KLBOV; j++) {
			strKlbyY[j].Format("%.0lf", m_priebehy1->operator[](priebeh).BodPriebehuKlbu(j, i));
			strKlbyZ[j].Format("%.0lf", m_priebehy2->operator[](priebeh).BodPriebehuKlbu(j, i));
		}
		// UR maju o jednu hodnotu menej, pocitaju sa z rozdielu
		// dvoch po sebe nasledujucich uhlov 
		for (int j = 0; j < POCET_UR; j++) {
			strURY[j].Format("%.2lf", m_priebehy1->operator [](priebeh).BodPriebehuUR(j, i-1));
			strURZ[j].Format("%.2lf", m_priebehy2->operator [](priebeh).BodPriebehuUR(j, i-1));
		}

		InsertRow(&m_ctlSuradnice, i, 2*POCET_UDAJOV, 
			strKlbyY[L_BEDROVY], strKlbyZ[L_BEDROVY], strKlbyY[L_KOLENO], strKlbyZ[L_KOLENO], 
			strKlbyY[L_CLENOK], strKlbyZ[L_CLENOK], strKlbyY[L_PATA] , strKlbyZ[L_PATA], 
			strKlbyY[L_PRSTY], strKlbyZ[L_PRSTY], 
			strKlbyY[P_BEDROVY], strKlbyZ[P_BEDROVY], strKlbyY[P_KOLENO], strKlbyZ[P_KOLENO], 
			strKlbyY[P_CLENOK], strKlbyZ[P_CLENOK], strKlbyY[P_PATA] , strKlbyZ[P_PATA], 
			strKlbyY[P_PRSTY], strKlbyZ[P_PRSTY],
			strURY[LUR_KCPR], strURZ[LUR_KCPR], strURY[LUR_KCPA], strURZ[LUR_KCPA], 
			strURY[PUR_KCPR], strURZ[PUR_KCPR], strURY[PUR_KCPA], strURZ[PUR_KCPA]
		);
	}
}


// vlozenie riadku do CListCtrl
int CTabulkaDlg::InsertRow(CListCtrl* pListCtrl, int nPos,int nNoOfCols, LPCTSTR pText, ...)
{
    va_list argList;
    va_start(argList, pText);

    ASSERT(nNoOfCols >= 1);
    int nIndex = pListCtrl->InsertItem(LVIF_TEXT | LVIF_STATE, nPos, pText, 0, LVIS_SELECTED, 0, 0);
    ASSERT(nIndex != -1);

	if (nIndex < 0) return(nIndex);
    for (int i = 1; i < nNoOfCols; i++) {
        LPCSTR p = va_arg(argList, LPCSTR);
        if (p != NULL)
            pListCtrl->SetItemText(nIndex, i, p);
    }
    va_end(argList);

    return(nIndex);
}


// opustenie dialogu
void CTabulkaDlg::OnBnClickedOk()
{
	OnOK();
}

