//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				TabulkaDlg.h
// Ucel suboru:			deklaracia triedy CTabulkaDlg - dialogove okno, v ktorom si pouzivatel moze
//						prezerat pozicie klbov a hodnoty UR
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 20.4.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#pragma once

#include "Chodza.h"
#include "afxwin.h"
#include "afxcmn.h"


class CTabulkaDlg : public CDialog
{
	DECLARE_DYNAMIC(CTabulkaDlg)
	
	// zoznam vykreslovanych priebehov v hornom grafe aplikacie
	std::vector<CChodza>* m_priebehy1;
	// zoznam vykreslovanych priebehov v dolnom grafe aplikacie
	std::vector<CChodza>* m_priebehy2;

	// pociatocne nastavenie dialogu
	virtual BOOL OnInitDialog();

public:
	CTabulkaDlg(CWnd* pParent = NULL);
	CTabulkaDlg(std::vector<CChodza>* priebehy1, std::vector<CChodza>* priebehy2);
	virtual ~CTabulkaDlg();

// Dialog Data
	enum { IDD = IDD_TABULKA };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	DECLARE_MESSAGE_MAP()

public:
	CListBox	m_lbChodze;
	CListCtrl	m_ctlSuradnice;
	CStatic		m_stPs;
	CStatic		m_stPss;

	// pri inicializacii
	void NaplnZoznamZobrChodzi(void);
	void NastavenieMienStlpcov(void);

	// pri zmene pozicie v listboxe zobrazujucom chodze treba CListCtrl 
	// naplnit novymi hodnotami podla zvolenej chodze
	afx_msg void OnLbnSelchangeList1();

	// nastavenie popiskov v dialogu a hodnot suradnic pre frame
	void Nastav(void);
	void NastavPopisky(void);
	void NastavNultyFrame(void);
	void NastavOstatneFrame(void);

	// vlozenie riadku do CListCtrl
	int InsertRow(CListCtrl* pListCtrl, int nPos, int nNoOfCols, LPCTSTR pText, ...);

	// zatvorenie dialogu
	afx_msg void OnBnClickedOk();
};

