//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				Udaje.cpp
// Ucel suboru:			dekfinicia triedy CUdaje - trieda uchovava zoznamy poloh klbov 
//						(len jednu suradnicu z polohy) a hodnot uhlovych rychlosti (UR)
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 20.4.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "udaje.h"


CUdaje::CUdaje(void)
{
}


CUdaje::~CUdaje(void)
{
}


// ulozenie polohy zadaneho klbu na koniec zoznamu
void CUdaje::UlozKlb(int nKlb, double fHodnota)
{
	switch(nKlb){
		case L_BEDROVY:	m_lstLbedrovy.push_back(fHodnota); break;
		case L_KOLENO:	m_lstLkoleno.push_back(fHodnota); break;
		case L_CLENOK:	m_lstLclenok.push_back(fHodnota); break;
		case L_PATA:	m_lstLpata.push_back(fHodnota); break;
		case L_PRSTY:	m_lstLprsty.push_back(fHodnota); break;
		case P_BEDROVY:	m_lstPbedrovy.push_back(fHodnota); break;
		case P_KOLENO:	m_lstPkoleno.push_back(fHodnota); break;
		case P_CLENOK:	m_lstPclenok.push_back(fHodnota); break;
		case P_PATA:	m_lstPpata.push_back(fHodnota); break;
		case P_PRSTY:	m_lstPprsty.push_back(fHodnota); break;
		default:		break;
	}
}


// vracia velkost zoznamu poloh pre zadany klb
int CUdaje::VelkostKlbu(int nKlb) 
{
	switch(nKlb){
		case L_BEDROVY:	return m_lstLbedrovy.size();
		case L_KOLENO:	return m_lstLkoleno.size();
		case L_CLENOK:	return m_lstLclenok.size();
		case L_PATA:	return m_lstLpata.size();
		case L_PRSTY:	return m_lstLprsty.size();
		case P_BEDROVY:	return m_lstPbedrovy.size();
		case P_KOLENO:	return m_lstPkoleno.size();
		case P_CLENOK:	return m_lstPclenok.size();
		case P_PATA:	return m_lstPpata.size();
		case P_PRSTY:	return m_lstPprsty.size();
		default: 		return 0;
	}
}


// vracia zadanu polohu (podla poradia v zozname) zadaneho klbu
double CUdaje::BodPriebehuKlbu(int nKlb, int nBod) 
{
	switch(nKlb){
		case L_BEDROVY:	return m_lstLbedrovy[nBod];
		case L_KOLENO:	return m_lstLkoleno[nBod];
		case L_CLENOK:	return m_lstLclenok[nBod];
		case L_PATA:	return m_lstLpata[nBod];
		case L_PRSTY:	return m_lstLprsty[nBod];
		case P_BEDROVY:	return m_lstPbedrovy[nBod];
		case P_KOLENO:	return m_lstPkoleno[nBod];
		case P_CLENOK:	return m_lstPclenok[nBod];
		case P_PATA:	return m_lstPpata[nBod];
		case P_PRSTY:	return m_lstPprsty[nBod];
		default: 		return 0;
	}
}


// ulozenie hodnoty zadanej UR na koniec zoznamu
void CUdaje::UlozUR(int nUR, double fHodnota)
{
	switch(nUR){
		case LUR_KCPR:	m_lstLURkcpr.push_back(fHodnota); break;
		case LUR_KCPA:	m_lstLURkcpa.push_back(fHodnota); break;
		case PUR_KCPR:	m_lstPURkcpr.push_back(fHodnota); break;
		case PUR_KCPA:	m_lstPURkcpa.push_back(fHodnota); break;
		default:	break;
	}
}


// vracia velkost zoznamu hodnot pre zadanu UR
int CUdaje::VelkostUR(int nUR)
{
	switch(nUR){
		case LUR_KCPR:	return m_lstLURkcpr.size();
		case LUR_KCPA:	return m_lstLURkcpa.size();
		case PUR_KCPR:	return m_lstPURkcpr.size();
		case PUR_KCPA:	return m_lstPURkcpa.size();
		default:	return 0;
	}
}


// vracia zadanu hodnotu (podla poradia v zozname) zadanej UR
double CUdaje::BodPriebehuUR(int nUR, int nBod) 
{
	switch(nUR){
		case LUR_KCPR:	return m_lstLURkcpr[nBod];
		case LUR_KCPA:	return m_lstLURkcpa[nBod];
		case PUR_KCPR:	return m_lstPURkcpr[nBod];
		case PUR_KCPA:	return m_lstPURkcpa[nBod];
		default:	return 0;
	}
}


// vracia maximalnu hodnotu polohy v zozname poloh zadaneho klbu
double CUdaje::NajdiKlbMax(int nKlb)
{
	switch (nKlb) {
		case L_BEDROVY:	return NajdiMax(&m_lstLbedrovy);
		case L_KOLENO:	return NajdiMax(&m_lstLkoleno);
		case L_CLENOK:	return NajdiMax(&m_lstLclenok);
		case L_PATA:	return NajdiMax(&m_lstLpata);
		case L_PRSTY:	return NajdiMax(&m_lstLprsty);
		case P_BEDROVY:	return NajdiMax(&m_lstPbedrovy);
		case P_KOLENO:	return NajdiMax(&m_lstPkoleno);
		case P_CLENOK:	return NajdiMax(&m_lstPclenok);
		case P_PATA:	return NajdiMax(&m_lstPpata);
		case P_PRSTY:	return NajdiMax(&m_lstPprsty);
		default:		return -1;
	}
}


// vracia minimalnu hodnotu polohy v zozname poloh zadaneho klbu
double CUdaje::NajdiKlbMin(int nKlb)
{
	switch (nKlb) {
		case L_BEDROVY:	return NajdiMin(&m_lstLbedrovy);
		case L_KOLENO:	return NajdiMin(&m_lstLkoleno);
		case L_CLENOK:	return NajdiMin(&m_lstLclenok);
		case L_PATA:	return NajdiMin(&m_lstLpata);
		case L_PRSTY:	return NajdiMin(&m_lstLprsty);
		case P_BEDROVY:	return NajdiMin(&m_lstPbedrovy);
		case P_KOLENO:	return NajdiMin(&m_lstPkoleno);
		case P_CLENOK:	return NajdiMin(&m_lstPclenok);
		case P_PATA:	return NajdiMin(&m_lstPpata);
		case P_PRSTY:	return NajdiMin(&m_lstPprsty);
		default:		return -1;
	}
}


// vracia maximalnu hodnotu v zozname hodnot zadanej UR
double CUdaje::NajdiURMax(int nUR)
{
	switch (nUR) {
		case LUR_KCPR:	return NajdiMax(&m_lstLURkcpr);
		case LUR_KCPA:	return NajdiMax(&m_lstLURkcpa);
		case PUR_KCPR:	return NajdiMax(&m_lstPURkcpr);
		case PUR_KCPA:	return NajdiMax(&m_lstPURkcpa);
		default:		return -1;
	}
}


// vracia minimalnu hodnotu v zozname hodnot zadanej UR
double CUdaje::NajdiURMin(int nUR)
{
	switch (nUR) {
		case LUR_KCPR:	return NajdiMin(&m_lstLURkcpr);
		case LUR_KCPA:	return NajdiMin(&m_lstLURkcpa);
		case PUR_KCPR:	return NajdiMin(&m_lstPURkcpr);
		case PUR_KCPA:	return NajdiMin(&m_lstPURkcpa);
		default:		return -1;
	}
}


// vracia maximalnu hodnotu v zadanom zozname hodnot
double CUdaje::NajdiMax(std::vector<double>* hodnoty)
{
	if (hodnoty->size() < 1)
		return -1;

	double max = hodnoty->operator[](0);
	for (UINT i = 1; i < hodnoty->size(); i++)
		if (max < hodnoty->operator[](i))
			max = hodnoty->operator[](i);

	return max;
}


// vracia minimalnu hodnotu v zadanom zozname hodnot
double CUdaje::NajdiMin(std::vector<double>* hodnoty)
{
	if (hodnoty->size() < 1)
		return -1;

	double min = hodnoty->operator[](0);
	for (UINT i = 1; i < hodnoty->size(); i++)
		if (min > hodnoty->operator[](i))
			min = hodnoty->operator[](i);

	return min;
}

