//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				Udaje.h
// Ucel suboru:			deklaracia triedy CUdaje - trieda uchovava zoznamy poloh klbov 
//						(len jednu suradnicu z polohy) a hodnot uhlovych rychlosti (UR)
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 20.4.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#pragma once
#include <vector>

// klby
#define POCET_KLBOV 10
enum ENUM_KLBY {
	L_BEDROVY,
	L_KOLENO,
	L_CLENOK,
	L_PATA,
	L_PRSTY,
	P_BEDROVY,
	P_KOLENO,
	P_CLENOK,
	P_PATA,
	P_PRSTY
};

// uhlove rychlosti (UR)
#define POCET_UR 4
enum ENUM_UHLRYCHLOSTI {
	LUR_KCPR,
	LUR_KCPA,
	PUR_KCPR,
	PUR_KCPA
};

// pocet klbov a uhlovych rychlosti
#define POCET_UDAJOV (POCET_KLBOV + POCET_UR)

// trieda uchovava zoznamy poloh klbov
// (len jednu suradnicu z polohy) a hodnot uhlovych rychlosti (UR)
class CUdaje
{
	// zoznamy poloh klbov
	std::vector<double> m_lstLbedrovy;
	std::vector<double> m_lstLkoleno;
	std::vector<double> m_lstLclenok;
	std::vector<double> m_lstLpata;
	std::vector<double> m_lstLprsty;
	std::vector<double> m_lstPbedrovy;
	std::vector<double> m_lstPkoleno;
	std::vector<double> m_lstPclenok;
	std::vector<double> m_lstPpata;
	std::vector<double> m_lstPprsty;
	// zoznamy hodnot uhlovych rychlosti
	std::vector<double> m_lstLURkcpr;
	std::vector<double> m_lstLURkcpa;
	std::vector<double> m_lstPURkcpr;
	std::vector<double> m_lstPURkcpa;

public:
	CUdaje(void);
	~CUdaje(void);

	// praca s klbmi
	void UlozKlb(int nKlb, double fHodnota);
	int VelkostKlbu(int nKlb);
	double BodPriebehuKlbu(int nKlb, int nBod);

	// praca s uhlovymi rychlostami (UR)
	void UlozUR(int nUR, double fHodnota);
	int VelkostUR(int nUR);
	double BodPriebehuUR(int nUR, int nBod);

	// hladanie extremov medzi polohami klbov
	double NajdiKlbMax(int nKlb);
	double NajdiKlbMin(int nKlb);

	// hladanie extremov medzi hodnotami uhlovych rychlosti (UR)
	double NajdiURMax(int nUR);
	double NajdiURMin(int nUR);

	// vseobecne vyhladavanie extremu v zozname
	double NajdiMax(std::vector<double>* hodnoty);
	double NajdiMin(std::vector<double>* hodnoty);
};
