//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				ViditelnostDlg.cpp
// Ucel suboru:			definicia triedy CViditelnostDlg - dialogove okno, v ktorom pouzivatel zadava,
//						ktore klby a UR chce, aby aplikacia vykreslovala v grafe
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Martin Soltis
// Naposledy zmenil:	Lucenic / 5.5.2005
// Poznamka:			UR = uhlova rychlost
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "Analyser.h"
#include "ViditelnostDlg.h"
#include <fstream>
#include <iostream>


IMPLEMENT_DYNAMIC(CViditelnostDlg, CDialog)
CViditelnostDlg::CViditelnostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CViditelnostDlg::IDD, pParent)
{
}


CViditelnostDlg::~CViditelnostDlg()
{
}


void CViditelnostDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK1, m_ch0);
	DDX_Control(pDX, IDC_CHECK2, m_ch1);
	DDX_Control(pDX, IDC_CHECK3, m_ch2);
	DDX_Control(pDX, IDC_CHECK4, m_ch3);
	DDX_Control(pDX, IDC_CHECK5, m_ch4);
	DDX_Control(pDX, IDC_CHECK6, m_ch5);
	DDX_Control(pDX, IDC_CHECK7, m_ch6);
	DDX_Control(pDX, IDC_CHECK8, m_ch7);
	DDX_Control(pDX, IDC_CHECK9, m_ch8);
	DDX_Control(pDX, IDC_CHECK10, m_ch9);
	DDX_Control(pDX, IDC_CHECK11, m_ch10);
	DDX_Control(pDX, IDC_CHECK12, m_ch11);
	DDX_Control(pDX, IDC_CHECK13, m_ch12);
	DDX_Control(pDX, IDC_CHECK14, m_ch13);
	DDX_Control(pDX, IDC_CHECK15, m_ch14);
	DDX_Control(pDX, IDC_CHECK16, m_ch15);
	DDX_Control(pDX, IDC_CHECK17, m_ch16);
	DDX_Control(pDX, IDC_CHECK18, m_ch17);
	DDX_Control(pDX, IDC_CHECK19, m_ch18);
	DDX_Control(pDX, IDC_CHECK20, m_ch19);
	DDX_Control(pDX, IDC_CHECK21, m_ch20);
	DDX_Control(pDX, IDC_CHECK22, m_ch21);
	DDX_Control(pDX, IDC_CHECK23, m_ch22);
	DDX_Control(pDX, IDC_CHECK24, m_ch23);
	DDX_Control(pDX, IDC_CHECK25, m_ch24);
	DDX_Control(pDX, IDC_CHECK26, m_ch25);
	DDX_Control(pDX, IDC_CHECK27, m_ch26);
	DDX_Control(pDX, IDC_CHECK28, m_ch27);
}


BEGIN_MESSAGE_MAP(CViditelnostDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


CViditelnostDlg::CViditelnostDlg(CGraf* pGraf1, CGraf* pGraf2)
	: CDialog(CViditelnostDlg::IDD)
{
	m_pGraf1 = pGraf1;
	m_pGraf2 = pGraf2;
	// vkladanie ukazovatelov na checkboxy dialogu do pola
	//poradie checkboxov v poli je:
	//horny graf: lave klby, prave klby, UR
	//dolny graf: lave klby, prave klby, UR
	int i = 0;
	m_pCheckboxy[i] = &m_ch0; i++;
	m_pCheckboxy[i] = &m_ch1; i++;
	m_pCheckboxy[i] = &m_ch2; i++;
	m_pCheckboxy[i] = &m_ch3; i++;
	m_pCheckboxy[i] = &m_ch4; i++;
	m_pCheckboxy[i] = &m_ch5; i++;
	m_pCheckboxy[i] = &m_ch6; i++;
	m_pCheckboxy[i] = &m_ch7; i++;
	m_pCheckboxy[i] = &m_ch8; i++;
	m_pCheckboxy[i] = &m_ch9; i++;
	m_pCheckboxy[i] = &m_ch10; i++;
	m_pCheckboxy[i] = &m_ch11; i++;
	m_pCheckboxy[i] = &m_ch12; i++;
	m_pCheckboxy[i] = &m_ch13; i++;
	m_pCheckboxy[i] = &m_ch14; i++;
	m_pCheckboxy[i] = &m_ch15; i++;
	m_pCheckboxy[i] = &m_ch16; i++;
	m_pCheckboxy[i] = &m_ch17; i++;
	m_pCheckboxy[i] = &m_ch18; i++;
	m_pCheckboxy[i] = &m_ch19; i++;
	m_pCheckboxy[i] = &m_ch20; i++;
	m_pCheckboxy[i] = &m_ch21; i++;
	m_pCheckboxy[i] = &m_ch22; i++;
	m_pCheckboxy[i] = &m_ch23; i++;
	m_pCheckboxy[i] = &m_ch24; i++;
	m_pCheckboxy[i] = &m_ch25; i++;
	m_pCheckboxy[i] = &m_ch26; i++;
	m_pCheckboxy[i] = &m_ch27;
}


// pociatocne nastavenie dialogu 
BOOL CViditelnostDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// nastavenie hodnot checboxov podla viditelnosti klbov v grafe
	for (int i = 0; i < POCET_KLBOV; i++) {
		if (m_pGraf1->ViditelnostKlbu(i))
			m_pCheckboxy[i]->SetCheck(BST_CHECKED);
		else
			m_pCheckboxy[i]->SetCheck(BST_UNCHECKED);
		
		if (m_pGraf2->ViditelnostKlbu(i))
			m_pCheckboxy[POCET_UDAJOV+i]->SetCheck(BST_CHECKED);
		else
			m_pCheckboxy[POCET_UDAJOV+i]->SetCheck(BST_UNCHECKED);
	}

	// nastavenie hodnot checboxov podla viditelnosti UR v grafe
	for (int i = 0; i < POCET_UR; i++) {
		if (m_pGraf1->ViditelnostUR(i))
			m_pCheckboxy[POCET_KLBOV + i]->SetCheck(BST_CHECKED);
		else
			m_pCheckboxy[POCET_KLBOV + i]->SetCheck(BST_UNCHECKED);
		
		if (m_pGraf2->ViditelnostUR(i))
			m_pCheckboxy[POCET_UDAJOV + POCET_KLBOV + i]->SetCheck(BST_CHECKED);
		else
			m_pCheckboxy[POCET_UDAJOV + POCET_KLBOV + i]->SetCheck(BST_UNCHECKED);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
}


// pri zavreti dialogu
void CViditelnostDlg::OnBnClickedOk()
{
	UlozViditelnostiDoGrafov();
	OnOK();
}


// ulozenie viditelnosti udajov do grafov
void CViditelnostDlg::UlozViditelnostiDoGrafov(void)
{
	// nastavenie viditelnosti klbov podla hodnot checboxov
	for (int i = 0; i < POCET_KLBOV; i++) {
		if (m_pCheckboxy[i]->GetCheck() == BST_CHECKED) 
			m_pGraf1->NastavViditelnostKlbu(i, true);
		else
			m_pGraf1->NastavViditelnostKlbu(i, false);
		
		if (m_pCheckboxy[POCET_UDAJOV + i]->GetCheck() == BST_CHECKED) 
			m_pGraf2->NastavViditelnostKlbu(i, true);
		else
			m_pGraf2->NastavViditelnostKlbu(i, false);
	}
	// nastavenie viditelnosti UR podla hodnot checboxov
	for (int i = 0; i < POCET_UR; i++) {
		if (m_pCheckboxy[POCET_KLBOV + i]->GetCheck() == BST_CHECKED) 
			m_pGraf1->NastavViditelnostUR(i, true);
		else
			m_pGraf1->NastavViditelnostUR(i, false);
		
		if (m_pCheckboxy[POCET_UDAJOV + POCET_KLBOV + i]->GetCheck() == BST_CHECKED) 
			m_pGraf2->NastavViditelnostUR(i, true);
		else
			m_pGraf2->NastavViditelnostUR(i, false);
	}
}