// BlueBoneDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BlueBone.h"
#include "BlueBoneDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlueBoneDlg dialog

CBlueBoneDlg::CBlueBoneDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlueBoneDlg::IDD, pParent),
    m_pkGLWnd(NULL), m_rootNode(NULL), m_pkCurrentNode(NULL), m_animation(NULL)
{
	//{{AFX_DATA_INIT(CBlueBoneDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  redraw = false;
  m_bCursor2 = false;
}

void CBlueBoneDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlueBoneDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATIC_GLWINDOW, m_kStaticControl);
}

BEGIN_MESSAGE_MAP(CBlueBoneDlg, CDialog)
	//{{AFX_MSG_MAP(CBlueBoneDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_TIMER()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_CLOSE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_COMMAND(ID_ANIMATION_CREATE_MANUALLY, OnAnimationCreateManually)
	ON_COMMAND(ID_ANIMATION_CREATE_USINGFILE, OnAnimationCreateUsingfile)
	ON_COMMAND(ID_ANIMATION_PLAY, OnAnimationPlay)
	ON_COMMAND(ID_SCENE_RESETCAMERA, OnSceneResetcamera)
	ON_COMMAND(ID_SCENE_RESETMODEL, OnSceneResetmodel)
	ON_COMMAND(ID_EXIT, OnExitmenu)
	ON_COMMAND(ID_ANIMATION_LOAD, OnAnimationLoad)
	ON_COMMAND(ID_ANIMATION_STOP, OnAnimationStop)
	ON_COMMAND(ID_TAKEKEYFRAME, OnTakekeyframe)
	ON_COMMAND(ID_ANIMATION_SAVE, OnAnimationSave)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_ANIMATION_PAUSE, OnAnimationPause)
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_SCENE_SHOWAXES, OnSceneShowAxes)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlueBoneDlg message handlers

BOOL CBlueBoneDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
  
  m_hCursor1 = LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE (IDC_3DARROW));
  m_hCursor2 = NULL;
  m_hCursor2 = LoadCursorFromFile("3dwns.ani");
  m_showAxes = false;
  if (m_hCursor2 == NULL) m_hCursor2 = LoadCursorFromFile("res/3dwns.ani");
  if (m_hCursor2 == NULL) m_hCursor2 = LoadCursorFromFile("obj/3dwns.ani");
  if (m_hCursor2 == NULL) m_hCursor2 = LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE (IDC_3DWNS));
  
  SetClassLong(m_hWnd, GCL_HCURSOR, (LONG) m_hCursor1);

  CString caption;
  caption.LoadString(IDS_APP_NAME);
  SetWindowText(caption);
  
	// TODO: Add extra initialization here
	m_pkGLWnd = new CglWnd(&m_kStaticControl);
	LoadBlueBoneModel();
	LoadAxesDefinitions("obj/axes.def");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBlueBoneDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBlueBoneDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	DrawRootNode();
  redraw = false;
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBlueBoneDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBlueBoneDlg::OnClose()
{
  OnExit();
	CDialog::OnClose();
}

void CBlueBoneDlg::LoadBlueBoneModel(void)
{
	m_rootNode = new CNode();

	//create "pelvis" mesh and assign to root node
	CMesh* pelvisMesh = new CMesh();
	pelvisMesh->LoadFromFile("obj/pelvis.obj");
	m_rootNode->SetMesh(pelvisMesh);
    SVertex tmp; tmp.x=0; tmp.y=30; tmp.z=0;
	m_rootNode->MoveBy(&tmp);
	m_rootNode->SetID(ID_PELVIS);
	
	//create "left femur" node
	CNode* l_femurNode = new CNode();
	CMesh* l_femurMesh = new CMesh();
	l_femurMesh->LoadFromFile("obj/l_femur.obj");
	l_femurNode->SetMesh(l_femurMesh);
	l_femurNode->MoveBy(l_femurMesh->GetOffsetVertex());
	l_femurNode->SetID(ID_L_FEMUR);
    m_rootNode->AddChildNode(l_femurNode);

    //create "right femur" node
	CNode* r_femurNode = new CNode();
	CMesh* r_femurMesh = new CMesh();
	r_femurMesh->LoadFromFile("obj/r_femur.obj");
	r_femurNode->SetMesh(r_femurMesh);
	r_femurNode->MoveBy(r_femurMesh->GetOffsetVertex());
    r_femurNode->SetID(ID_R_FEMUR);
    m_rootNode->AddChildNode(r_femurNode);

    //create "left lower leg" node
	CNode* l_lower_legNode = new CNode();
	CMesh* l_lower_legMesh = new CMesh();
	l_lower_legMesh->LoadFromFile("obj/l_lower_leg.obj");
	l_lower_legNode->SetMesh(l_lower_legMesh);
	l_lower_legNode->MoveBy(l_lower_legMesh->GetOffsetVertex());
	l_lower_legNode->MoveBy(l_femurMesh->GetOffsetVertex(), true); //substract offset (root, parent)
	l_lower_legNode->SetID(ID_L_LOWER_LEG);
    l_femurNode->AddChildNode(l_lower_legNode);

    //create "right lower leg" node
	CNode* r_lower_legNode = new CNode();
	CMesh* r_lower_legMesh = new CMesh();
	r_lower_legMesh->LoadFromFile("obj/r_lower_leg.obj");
    r_lower_legNode->SetMesh(r_lower_legMesh);
	r_lower_legNode->MoveBy(r_lower_legMesh->GetOffsetVertex());
	r_lower_legNode->MoveBy(r_femurMesh->GetOffsetVertex(), true);
	r_lower_legNode->SetID(ID_R_LOWER_LEG);
    r_femurNode->AddChildNode(r_lower_legNode);

    //create "left talur" node
	CNode* l_talusNode = new CNode();
	CMesh* l_talusMesh = new CMesh();
	l_talusMesh->LoadFromFile("obj/l_talus.obj");
    l_talusNode->SetMesh(l_talusMesh);
	l_talusNode->MoveBy(l_talusMesh->GetOffsetVertex());
	l_talusNode->MoveBy(l_lower_legMesh->GetOffsetVertex(), true);
	l_talusNode->SetID(ID_L_TALUS);
    l_lower_legNode->AddChildNode(l_talusNode);

    //create "right foot" node
	CNode* l_footNode = new CNode();
	CMesh* l_footMesh = new CMesh();
	l_footMesh->LoadFromFile("obj/l_foot.obj");
	l_footNode->SetMesh(l_footMesh);
	l_footNode->MoveBy(l_footMesh->GetOffsetVertex());
	l_footNode->MoveBy(l_talusMesh->GetOffsetVertex(), true);
	l_footNode->SetID(ID_L_FOOT);
    l_talusNode->AddChildNode(l_footNode);

    //create "right talur" node
	CNode* r_talusNode = new CNode();
	CMesh* r_talusMesh = new CMesh();
	r_talusMesh->LoadFromFile("obj/r_talus.obj");
    r_talusNode->SetMesh(r_talusMesh);
	r_talusNode->MoveBy(r_talusMesh->GetOffsetVertex());
	r_talusNode->MoveBy(r_lower_legMesh->GetOffsetVertex(), true);
	r_talusNode->SetID(ID_R_TALUS);
    r_lower_legNode->AddChildNode(r_talusNode);

    //create "right foot" node
	CNode* r_footNode = new CNode();
	CMesh* r_footMesh = new CMesh();
	r_footMesh->LoadFromFile("obj/r_foot.obj");
	r_footNode->SetMesh(r_footMesh);
	r_footNode->MoveBy(r_footMesh->GetOffsetVertex());
	r_footNode->MoveBy(r_talusMesh->GetOffsetVertex(), true);
	r_footNode->SetID(ID_R_FOOT);
    r_talusNode->AddChildNode(r_footNode);

    //create "left toe 1" node
	CNode* l_toe1Node = new CNode();
	CMesh* l_toe1Mesh = new CMesh();
	l_toe1Mesh->LoadFromFile("obj/l_toe1.obj");
	l_toe1Node->SetMesh(l_toe1Mesh);
	l_toe1Node->MoveBy(l_toe1Mesh->GetOffsetVertex());
	l_toe1Node->MoveBy(l_footMesh->GetOffsetVertex(), true);
	l_toe1Node->SetID(ID_L_TOE1);
    l_footNode->AddChildNode(l_toe1Node);

    //create "left toe 2" node
	CNode* l_toe2Node = new CNode();
	CMesh* l_toe2Mesh = new CMesh();
	l_toe2Mesh->LoadFromFile("obj/l_toe2.obj");
	l_toe2Node->SetMesh(l_toe2Mesh);
	l_toe2Node->MoveBy(l_toe2Mesh->GetOffsetVertex());
	l_toe2Node->MoveBy(l_footMesh->GetOffsetVertex(), true);
	l_toe2Node->SetID(ID_L_TOE2);
    l_footNode->AddChildNode(l_toe2Node);

    //create "left toe 3" node
	CNode* l_toe3Node = new CNode();
	CMesh* l_toe3Mesh = new CMesh();
	l_toe3Mesh->LoadFromFile("obj/l_toe3.obj");
	l_toe3Node->SetMesh(l_toe3Mesh);
	l_toe3Node->MoveBy(l_toe3Mesh->GetOffsetVertex());
	l_toe3Node->MoveBy(l_footMesh->GetOffsetVertex(), true);
	l_toe3Node->SetID(ID_L_TOE3);
    l_footNode->AddChildNode(l_toe3Node);

    //create "left toe 4" node
	CNode* l_toe4Node = new CNode();
	CMesh* l_toe4Mesh = new CMesh();
	l_toe4Mesh->LoadFromFile("obj/l_toe4.obj");
	l_toe4Node->SetMesh(l_toe4Mesh);
	l_toe4Node->MoveBy(l_toe4Mesh->GetOffsetVertex());
	l_toe4Node->MoveBy(l_footMesh->GetOffsetVertex(), true);
	l_toe4Node->SetID(ID_L_TOE4);
    l_footNode->AddChildNode(l_toe4Node);

    //create "left toe 5" node
	CNode* l_toe5Node = new CNode();
	CMesh* l_toe5Mesh = new CMesh();
	l_toe5Mesh->LoadFromFile("obj/l_toe5.obj");
	l_toe5Node->SetMesh(l_toe5Mesh);
	l_toe5Node->MoveBy(l_toe5Mesh->GetOffsetVertex());
	l_toe5Node->MoveBy(l_footMesh->GetOffsetVertex(), true);
	l_toe5Node->SetID(ID_L_TOE5);
    l_footNode->AddChildNode(l_toe5Node);

    //create "right toe 1" node
	CNode* r_toe1Node = new CNode();
	CMesh* r_toe1Mesh = new CMesh();
	r_toe1Mesh->LoadFromFile("obj/r_toe1.obj");
	r_toe1Node->SetMesh(r_toe1Mesh);
	r_toe1Node->MoveBy(r_toe1Mesh->GetOffsetVertex());
	r_toe1Node->MoveBy(r_footMesh->GetOffsetVertex(), true);
	r_toe1Node->SetID(ID_R_TOE1);
    r_footNode->AddChildNode(r_toe1Node);

    //create "right toe 2" node
	CNode* r_toe2Node = new CNode();
	CMesh* r_toe2Mesh = new CMesh();
	r_toe2Mesh->LoadFromFile("obj/r_toe2.obj");
	r_toe2Node->SetMesh(r_toe2Mesh);
	r_toe2Node->MoveBy(r_toe2Mesh->GetOffsetVertex());
	r_toe2Node->MoveBy(r_footMesh->GetOffsetVertex(), true);
	r_toe2Node->SetID(ID_R_TOE2);
    r_footNode->AddChildNode(r_toe2Node);

    //create "right toe 3" node
	CNode* r_toe3Node = new CNode();
	CMesh* r_toe3Mesh = new CMesh();
	r_toe3Mesh->LoadFromFile("obj/r_toe3.obj");
	r_toe3Node->SetMesh(r_toe3Mesh);
	r_toe3Node->MoveBy(r_toe3Mesh->GetOffsetVertex());
	r_toe3Node->MoveBy(r_footMesh->GetOffsetVertex(), true);
	r_toe3Node->SetID(ID_R_TOE3);
    r_footNode->AddChildNode(r_toe3Node);

    //create "right toe 4" node
	CNode* r_toe4Node = new CNode();
	CMesh* r_toe4Mesh = new CMesh();
	r_toe4Mesh->LoadFromFile("obj/r_toe4.obj");
	r_toe4Node->SetMesh(r_toe4Mesh);
	r_toe4Node->MoveBy(r_toe4Mesh->GetOffsetVertex());
	r_toe4Node->MoveBy(r_footMesh->GetOffsetVertex(), true);
	r_toe4Node->SetID(ID_R_TOE4);
    r_footNode->AddChildNode(r_toe4Node);

    //create "right toe 5" node
	CNode* r_toe5Node = new CNode();
	CMesh* r_toe5Mesh = new CMesh();
	r_toe5Mesh->LoadFromFile("obj/r_toe5.obj");
	r_toe5Node->SetMesh(r_toe5Mesh);
	r_toe5Node->MoveBy(r_toe5Mesh->GetOffsetVertex());
	r_toe5Node->MoveBy(r_footMesh->GetOffsetVertex(), true);
	r_toe5Node->SetID(ID_R_TOE5);
    r_footNode->AddChildNode(r_toe5Node);
}



void CBlueBoneDlg::OnTimer(UINT nIDEvent)
{
	m_animation->OnTimer(m_rootNode);
  SetDlgCaption();
  DrawRootNode();
}

void CBlueBoneDlg::LoadAxesDefinitions(const char* acFileName)
{
	std::ifstream input(acFileName);
	//read in the axes definition
	for (unsigned int i=0; i<ID_LAST_NODE; i++)
	{
		unsigned int uiID;
		input >> uiID;
		unsigned int uiAxesCount = 0;
		input >> uiAxesCount;
		for (unsigned int j=0; j<uiAxesCount; j++)
		{
			GLfloat afAxis[] = {0.0f, 0.0f, 0.0f, -90.0f, 90.0f};
			input >> afAxis[0] >> afAxis[1] >> afAxis[2] >> afAxis[3] >> afAxis[4];
			CNode* pkNode = m_rootNode->FindNode(uiID);
			if (pkNode)
				pkNode->AddAxis(afAxis);
		}
	}
}

void CBlueBoneDlg::OnMouseMove(UINT nFlags, CPoint point)
{
  if (m_bCursor2) SetCursor(m_hCursor2);
  CRect glViewport_rect;
	m_kStaticControl.GetClientRect(&glViewport_rect);

	if (glViewport_rect.PtInRect(point))
	{
    CPoint p = point;
    // toto treba odpocitat, lebo je to nejake nepresne
    // (tie hodnoty boli zistene empiricky)
    p.x -= 3;
    p.y -= 2;
		m_pkGLWnd->OnMouseMove(nFlags, p);
	}
  
  if (redraw)
  {
    redraw = false;
    DrawRootNode();
  }
}

void CBlueBoneDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
  CRect glViewport_rect;
	m_kStaticControl.GetClientRect(&glViewport_rect);

	if (glViewport_rect.PtInRect(point))
	{
    CPoint p = point;
    // toto treba odpocitat, lebo je to nejake nepresne
    // (tie hodnoty boli zistene empiricky)
    p.x -= 3;
    p.y -= 2;
    m_pkGLWnd->OnLButtonDown(nFlags, p);
	}

  if (m_pkCurrentNode)
  {
    m_bCursor2 = true;
    SetCursor(m_hCursor2);
  }
  else
  {
    m_bCursor2 = false;
  }

	CDialog::OnLButtonDown(nFlags, point);
}

void CBlueBoneDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	CRect glViewport_rect;
	m_kStaticControl.GetClientRect(&glViewport_rect);

	if (glViewport_rect.PtInRect(point))
	{
    CPoint p = point;
    // toto treba odpocitat, lebo je to nejake nepresne
    // (tie hodnoty boli zistene empiricky)
    p.x -= 3;
    p.y -= 2;
    m_pkGLWnd->OnRButtonDown(nFlags, p);
	}

  if (m_pkCurrentNode)
  {
    m_bCursor2 = true;
    SetCursor(m_hCursor2);
  }
  else
  {
    m_bCursor2 = false;
  }

	CDialog::OnRButtonDown(nFlags, point);
}

BOOL CBlueBoneDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	m_pkGLWnd->OnMouseWheel(nFlags, zDelta, pt);
  DrawRootNode();
	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

void CBlueBoneDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
  m_bCursor2 = false;
	m_pkGLWnd->OnLButtonUp(nFlags, point);
	CDialog::OnLButtonUp(nFlags, point);
  if (redraw) DrawRootNode();
}

void CBlueBoneDlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
  m_bCursor2 = false;
	m_pkGLWnd->OnRButtonUp(nFlags, point);
	CDialog::OnRButtonUp(nFlags, point);
  if (redraw) DrawRootNode();
}

void CBlueBoneDlg::OnExit()
{
  if (m_animation) 
  {
    delete m_animation;
    m_animation = NULL;
  }
  if (m_pkGLWnd) {
		delete m_pkGLWnd;
    m_pkGLWnd = NULL;
  }
	if (m_rootNode) {
		delete m_rootNode;
    m_rootNode = NULL;
  }
}

void CBlueBoneDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	m_pkGLWnd->ResetCamera();
	DrawRootNode();
	CDialog::OnLButtonDblClk(nFlags, point);
}

void CBlueBoneDlg::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	for (unsigned int i=1; i<=ID_LAST_NODE; i++)
		m_rootNode->FindNode(i)->ResetRotation();
	DrawRootNode();
	
	CDialog::OnRButtonDblClk(nFlags, point);
}

void CBlueBoneDlg::OnSize(UINT nType, int cx, int cy) 
{
	CRect rcDialog_new, rect;
  GetWindowRect(&rcDialog_new);

  if ( IsWindow(m_kStaticControl) )
  {
    m_kStaticControl.GetWindowRect(&rect);
    
    rect.right += rcDialog_new.Width() - m_rcDialog.Width();
    rect.bottom += rcDialog_new.Height() - m_rcDialog.Height();;
    ScreenToClient(&rect);
    m_kStaticControl.MoveWindow(rect, TRUE);
      
    GetWindowRect(&m_rcDialog);
    m_kStaticControl.GetClientRect(&rect);
    m_pkGLWnd->OnResize(rect.Width(), rect.Height());
  }
}

void CBlueBoneDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	GetWindowRect(&m_rcDialog);
}


//------------------- funkcie menu ----------------------------------------

void CBlueBoneDlg::OnAnimationCreateManually() 
{
  //OnSceneResetcamera();
  OnSceneResetmodel();
  if (m_animation) 
  {
    delete m_animation;
    m_animation = NULL;
  }
  m_animation = new CAnimation;
  CMenu* menu = GetMenu();
  menu->EnableMenuItem(ID_ANIMATION_PLAY, MF_ENABLED);
  menu->EnableMenuItem(ID_TAKEKEYFRAME, MF_ENABLED);
  menu->EnableMenuItem(ID_ANIMATION_SAVE, MF_ENABLED);
  DrawMenuBar();
 	m_animation->TakeKeyFrame(true);

  SetDlgCaption();
}

void CBlueBoneDlg::OnAnimationCreateUsingfile() 
{
  TCHAR szFilters[] = _T("BlueBone Data files (*.bbd)|*.bbd||");
  
	CFileDialog fileDialog(TRUE, "bbd", NULL, OFN_HIDEREADONLY, szFilters);
  
	if (fileDialog.DoModal() == IDOK) {
    if (m_animation) {
      delete m_animation;
      m_animation = NULL;
    }
		m_animation = new CAnimation(fileDialog.GetFileName());
    CMenu* menu = GetMenu();
    menu->EnableMenuItem(ID_ANIMATION_PLAY, MF_ENABLED);
    menu->EnableMenuItem(ID_ANIMATION_SAVE, MF_ENABLED);
    DrawMenuBar();
    
    SetDlgCaption();
  }
}

void CBlueBoneDlg::OnAnimationPlay() 
{
  m_animation->Play();
}

void CBlueBoneDlg::OnSceneResetcamera() 
{
  m_pkGLWnd->ResetCamera();
  DrawRootNode();	
}

void CBlueBoneDlg::OnSceneResetmodel() 
{
	for (unsigned int i=1; i<=ID_LAST_NODE; i++)
		m_rootNode->FindNode(i)->ResetRotation();
	DrawRootNode();	
}

void CBlueBoneDlg::OnExitmenu() 
{
  OnExit();
  OnOK();
}

void CBlueBoneDlg::OnAnimationLoad() 
{
  TCHAR szFilters[] = _T("BlueBone Animation files (*.bba)|*.bba||");
  
	CFileDialog fileDialog(TRUE, "bba", NULL, OFN_HIDEREADONLY, szFilters);
  
	if (fileDialog.DoModal() == IDOK) {
    if (m_animation) {
      delete m_animation;
      m_animation = NULL;
    }
		m_animation = new CAnimation;
    m_animation->Load(fileDialog.GetFileName());
    CMenu* menu = GetMenu();
    menu->EnableMenuItem(ID_ANIMATION_PLAY, MF_ENABLED);
   
    SetDlgCaption();
  }	
}

void CBlueBoneDlg::OnAnimationStop() 
{
  m_animation->Stop();
  OnSceneResetmodel();
  SetDlgCaption();
}

void CBlueBoneDlg::OnTakekeyframe() 
{
  m_animation->TakeKeyFrame(FALSE);
  
  SetDlgCaption();
}

void CBlueBoneDlg::OnAnimationSave() 
{
  static char acFilter[] = "BlueBone Animation files (*.bba)|*.bba||";
	CFileDialog kDialog(FALSE, "bba", NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, acFilter);
	if (kDialog.DoModal() == IDOK)
  {
    if (!m_animation) return;
    m_animation->Save(kDialog.GetFileName());
    SetDlgCaption();
  }
}

void CBlueBoneDlg::SetDlgCaption()
{
  CString str, caption;
  caption.LoadString(IDS_APP_NAME);
  int loops = m_animation->GetLoopsCount();
  int current_frame = m_animation->GetFramesCount() ? (m_animation->GetCurrentFrame() + 1) : 0;
  if (loops != -1)
  {
    str.Format(" - %s : FPS %d, Frames %d/%d, Loops %d/%d", m_animation->GetFileName(), m_animation->GetFPS(), 
      current_frame, m_animation->GetFramesCount(), 
      m_animation->GetCurrentLoop() + 0, loops);
  }
  else
  {
    str.Format(" - %s : FPS %d, Frames %d/%d, Loops %d/INF", m_animation->GetFileName(), m_animation->GetFPS(), 
      current_frame, m_animation->GetFramesCount(), 
      m_animation->GetCurrentLoop() + 1);
  }
  caption += str;
  SetWindowText(caption);
}

void CBlueBoneDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
}

void CBlueBoneDlg::OnAnimationPause() 
{
  m_animation->Pause();
}

void CBlueBoneDlg::OnAbout() 
{
  CAboutDlg dlgAbout;
  dlgAbout.DoModal();	
}

void CBlueBoneDlg::OnSceneShowAxes()
{
	m_showAxes = !m_showAxes;
	DrawRootNode();	
	// Get the popup menu which contains the "Test" menu item.
	CMenu* mmenu = GetMenu();
	CMenu* submenu = mmenu->GetSubMenu(1);

	// Check the state of the "Test" menu item. Check the menu item
	// if it is currently unchecked. Otherwise, uncheck the menu item
	// if it is not currently checked.
	UINT state = submenu->GetMenuState(ID_SCENE_SHOWAXES, MF_BYCOMMAND);
	ASSERT(state != 0xFFFFFFFF);

	if (state & MF_CHECKED)
		submenu->CheckMenuItem(ID_SCENE_SHOWAXES, MF_UNCHECKED | MF_BYCOMMAND);
	else
		submenu->CheckMenuItem(ID_SCENE_SHOWAXES, MF_CHECKED | MF_BYCOMMAND);
}
