// BlueBoneDlg.h : header file
//

#include "afxwin.h"
#include "glWnd.h"
#include <fstream>

#if !defined(AFX_BLUEBONEDLG_H__00839C2C_D43D_4BF5_9957_25F5E6C05063__INCLUDED_)
#define AFX_BLUEBONEDLG_H__00839C2C_D43D_4BF5_9957_25F5E6C05063__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "animation.h"

/////////////////////////////////////////////////////////////////////////////
// CBlueBoneDlg dialog

class CBlueBoneDlg : public CDialog
{
// Construction
public:
	CBlueBoneDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBlueBoneDlg)
	enum { IDD = IDD_BLUEBONE_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBlueBoneDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON   m_hIcon;
  HCURSOR m_hCursor1;
  HCURSOR m_hCursor2;
  BOOL    m_bCursor2;

	// Generated message map functions
	//{{AFX_MSG(CBlueBoneDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
  afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnClose();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnAnimationCreateManually();
	afx_msg void OnAnimationCreateUsingfile();
	afx_msg void OnAnimationPlay();
	afx_msg void OnSceneResetcamera();
	afx_msg void OnSceneResetmodel();
	afx_msg void OnExitmenu();
	afx_msg void OnAnimationLoad();
	afx_msg void OnAnimationStop();
	afx_msg void OnTakekeyframe();
	afx_msg void OnAnimationSave();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnAnimationPause();
	afx_msg void OnAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
  CRect m_rcDialog;
	CglWnd* m_pkGLWnd;
	CStatic m_kStaticControl;
	CNode*  m_rootNode;
	CNode*  m_pkCurrentNode;
	
  //std::vector< std::vector<SNodeMov> > m_kFrames;
  CAnimation *m_animation;

public:
  BOOL redraw;
  bool    m_showAxes;
  void OnExit();
  void LoadBlueBoneModel(void);
  void DrawRootNode(void)
	{
		m_pkGLWnd->DrawScene(m_rootNode);
	}
  
  void SetCurrentNode(const unsigned int uiCurrentNode)
	{
		//if (m_pkCurrentNode)
		//	m_pkCurrentNode->EnableHighlight(false);
		m_pkCurrentNode = m_rootNode->FindNode(uiCurrentNode);
		//if (m_pkCurrentNode)
		//	m_pkCurrentNode->EnableHighlight();
	}

	CNode* GetCurrentNode(void)
	{
		return m_pkCurrentNode;
	}

	CNode* GetRootNode()
	{
		return m_rootNode;
	}
  
  void LoadAxesDefinitions(const char* acFileName);
  void SetDlgCaption();
  afx_msg void OnSceneShowAxes();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLUEBONEDLG_H__00839C2C_D43D_4BF5_9957_25F5E6C05063__INCLUDED_)
