#pragma once
#include "Vector3.h"

class CCamera
{
public:
	CCamera ();
	CCamera (CVector3 kUp, CVector3 kLeft, CVector3 kLocation, CVector3 kDirection) ;
	
	virtual ~CCamera () 
	{/*****/}

	void MoveForward (double dQuantum) 
	/* UCEL:   pohyb kamery v smere pohladu
	   VSTUP:  dQuantum - hodnota posunutia
	   VYSTUP: -
	*/
	{ m_kLocation += m_kDirection*dQuantum; }


	void MoveBackward (double dQuantum) 
	/* UCEL:   pohyb kamery proti smeru pohladu
	   VSTUP:  dQuantum - hodnota posunutia
	   VYSTUP: -
	*/
	{ m_kLocation -= m_kDirection*dQuantum; }


	void StrafeRight (double dQuantum) 
	/* UCEL:   pohyb kamery vpravo
	   VSTUP:  dQuantum - hodnota posunutia
	   VYSTUP: -
	*/
	{ 
		m_kLocation += m_kLeft*(-dQuantum); 
		m_kArcCenter += m_kLeft*(-dQuantum);
	}


	void StrafeLeft (double dQuantum) 
	/* UCEL:   pohyb kamery vlavo
	   VSTUP:  dQuantum - hodnota posunutia
	   VYSTUP: -
	*/
	{ 
		m_kLocation += m_kLeft*dQuantum; 
		m_kArcCenter += m_kLeft*dQuantum;
	}


	void StrafeUp (double dQuantum) 
	/* UCEL:   pohyb kamery nahor
	   VSTUP:  dQuantum - hodnota posunutia
	   VYSTUP: -
	*/
	{ 
		m_kLocation += m_kUp*dQuantum; 
		m_kArcCenter += m_kUp*dQuantum;
	}


	void StrafeDown (double dQuantum) 
	/* UCEL:   pohyb kamery nadol
	   VSTUP:  dQuantum - hodnota posunutia
	   VYSTUP: -
	*/
	{	
		m_kLocation += m_kUp*(-dQuantum); 
		m_kArcCenter += m_kUp*(-dQuantum);
	}
	

	void TurnLeft (double dQuantum);
	void LookDown (double dQuantum);

	void ArcX (double dQuantum);
	void ArcY (double dQuantum);

	CVector3& Up () 
	/* UCEL:   spristupnenie vektora Up
	   VSTUP:  -
	   VYSTUP: referencia na vektor Up
	*/
	{ return m_kUp; }


	const CVector3 Up () const 
	/* UCEL:   spristupnenie vektora Up
	   VSTUP:  -
	   VYSTUP: konstantny vektor Up
	*/
	{ return m_kUp; }


	CVector3& Left () 
	/* UCEL:   spristupnenie vektora Left
	   VSTUP:  -
	   VYSTUP: referencia na vektor Left
	*/
	{ return m_kLeft; }


	const CVector3 Left () const 
	/* UCEL:   spristupnenie vektora Left
	   VSTUP:  -
	   VYSTUP: konstantny vektor Left
	*/
	{ return m_kLeft; }


	CVector3& Direction () 
	/* UCEL:   spristupnenie vektora Direction
	   VSTUP:  -
	   VYSTUP: referencia na vektor Direction
	*/
	{ return m_kDirection; }


	const CVector3 Direction () const 
	/* UCEL:   spristupnenie vektora Direction
	   VSTUP:  -
	   VYSTUP: konstantny vektor Direction
	*/
	{ return m_kDirection; }


	CVector3& Location () 
	/* UCEL:   spristupnenie vektora Location
	   VSTUP:  -
	   VYSTUP: referencia na vektor Location
	*/
	{ return m_kLocation; }


	const CVector3 Location () const 
	/* UCEL:   spristupnenie vektora Location
	   VSTUP:  -
	   VYSTUP: konstantny vektor Location
	*/
	{ return m_kLocation; }

	void SetViewMatrix ();

protected:
	CVector3 m_kUp, m_kLeft, m_kDirection, m_kLocation;
	CVector3 m_kArcCenter;
};
