#pragma once
#include "Vector3.h"

class CMatrix3
{
public:
	CMatrix3 () 
	/* UCEL:   bezparametricky konstruktor
	   VSTUP:  -
	   VYSTUP: -
	*/
	{/*****/} 


	CMatrix3 (double aadNew [3][3]) 
	/* UCEL:   konstruktor
	   VSTUP:  aadNew - prvky matice
	   VYSTUP: -
	*/
	{ memcpy (m_aadItem, aadNew, 9*sizeof(double)); }

	
	CMatrix3 (const CVector3 kRow1, const CVector3 kRow2, const CVector3 kRow3);
	CMatrix3 (const double d11, const double d12, const double d13,
			const double d21, const double d22, const double d23, 
			const double d31, const double d32, const double d33);
	CMatrix3 (double aadNew [16]);
	CMatrix3 (const CMatrix3& rkMatrix);
	
	~CMatrix3 () 
	/* UCEL:   destruktor
	   VSTUP:  -
	   VYSTUP: -
	*/
	{/*****/}

	void Transpose ();
	const double Determinant () const;
	void FromAngleAxis (const CVector3 kAxis, const double dAngleDeg);

	double* operator [] (int iI) const
	/* UCEL:   indexovaci operator
	   VSTUP:  iI - riadok matice
	   VYSTUP: pole prvkov tvoria iI-ty riadok matice
	*/
	{ return (double*) &m_aadItem [iI][0]; }

	const CMatrix3 operator+ (const CMatrix3& rkM) const;
	const CMatrix3 operator- (const CMatrix3& rkM) const;
	const CMatrix3 operator* (const CMatrix3& rkM) const;
	
	const CMatrix3 operator* (const double dFactor) const;
	const CMatrix3 operator+ (const double dFactor) const;


	const CMatrix3 operator- (const double dFactor) const
	/* UCEL:   rozdiel matice a skalara
	   VSTUP:  dFactor - skalarny operand rozdielu
	   VYSTUP: rozdiel matice reprezentovaniej instanciou a parametra
	*/
	{ return operator+ (-dFactor); }

	const CVector3 operator* (const CVector3& rkVector) const;
	CMatrix3& operator= (const CMatrix3& rkM);
	const bool operator== (const CMatrix3& rkM) const;
	const bool operator!= (const CMatrix3& rkM) const;

protected:
	double m_aadItem [3][3];
public:
	static const CMatrix3 IDENTITY;
	static const CMatrix3 ZERO;
};
