#pragma once
#include "StdAfx.h"
#include "bluebone.h"
#include <vector>

extern CBlueBoneApp theApp;
class CBlueBoneDlg;
struct SVertex
{
	GLfloat x, y, z;
};

struct SNormal
{
	GLfloat x, y, z;
};

struct SFace
{
	int indexV1, indexV2, indexV3;	// indexy do pola vrcholov
	int indexN1, indexN2, indexN3;  // indexy do pola normal
};

//os, okolo ktorej sa kosti otacaju
struct SAxis
{
  GLfloat x, y, z, //urcenie osi
          l_limit, //dolny restrikcny limit rotacie
          u_limit; //horny restrikcny limit rotacie
};


class CMesh
{
public:
	CMesh();
	CMesh(const CMesh& rkOperand);
	~CMesh();

	void Render() const;
	void DrawAxes() const;
private:
	SVertex* m_Vertices;
	SNormal* m_Normals;
	SFace* m_Faces;
	unsigned int m_VertexCount, m_NormalCount, m_FaceCount;
    SVertex m_offset;   //bod, o ktory posunieme vsetky vrcholy
//#####################################################################
	//added by peto
	std::vector<SAxis> m_kAxes;
//#####################################################################
	GLfloat m_afMaterialAmbient[4], m_afMaterialDiffuse[4];
	GLfloat m_afMaterialEmissive[4], m_afMaterialSpecular[4], m_fMaterialPower;
public:
	SVertex * GetOffsetVertex();
	void LoadFromFile(const char* acFileName);
		void AddAxis(const GLfloat* afVector)
	{
		SAxis axis;
		ZeroMemory(&axis, sizeof(SAxis));
		axis.x = afVector[0];
		axis.y = afVector[1];
		axis.z = afVector[2];
		m_kAxes.push_back(axis);
	}
private:
	void IssueMaterial(void);
	
};
