#pragma once
#include "Node.h"
#include "Camera.h"

// CglWnd

class CglWnd : public CWnd
{
	DECLARE_DYNAMIC(CglWnd)

public:
	CglWnd(CWnd* pkWindow);
	virtual ~CglWnd();

protected:
	DECLARE_MESSAGE_MAP()

//private:
public:
	CWnd* m_pkWnd;
	HWND m_hWnd;
	HDC m_hDC;
	HGLRC m_hglRC;
	bool SetPixelFormat(void);
	CCamera* m_pkCamera;
	int m_iLastMouseX, m_iLastMouseY;
	CNode* m_pkLastActiveNode;
public:
	void OnResize(int iWidth, int iHeight);
  void ResetCamera();
private:
	void InitGL(void);
	bool OnCreate();
public:
	void DrawScene(CNode* pkRoot);
	
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
  afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	unsigned int DoPick(int iX, int iY);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
};


