//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				AVIExtractor.h
// Ucel suboru:			deklaracia triedy CAVIExtractor
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 20.4.2005
// Poznamka:			Abstraktna trieda, implementujuca pristup        
//						k AVI suborom, za ucelom extrakcie obrazkov.     
//						Export do jednotlivych formatov je realizovany       
//						dedenim od tejto triedy a prekrytim metody WriteFrame 
//						Autor: Juraj Hajek, 2000/2001
//______________________________________________________________________________________________________

//!
//!                     
//!

#if !defined(AFX_AVIEXTRACTOR_H__685EA323_486F_11D5_A4EB_F3D749894D5B__INCLUDED_)
#define AFX_AVIEXTRACTOR_H__685EA323_486F_11D5_A4EB_F3D749894D5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VideoExtractor.h"
#include <vfw.h>
#include "Frame.h"

class C4FBitmap;


class CAviExtractor : public CVideoExtractor
{
protected:
    PAVIFILE m_ppFile;		// otvoreny AVI subor
    PAVISTREAM m_ppAvi;		// aktualny videostream

public:
	CAviExtractor();
	CAviExtractor(CString &strVideoFile);

	// prekryjeme funkcie, ktore priamo nezavisia od formatu,
	// v akom su ulozene vyextrahovane snimky

	// otvorenie a inicializacia video streamu
    HRESULT OpenFile(CString &strVideoFilename);
    // uzavretie a uvolnenie video streamu
    HRESULT CloseFile();

    // extrakcia do obrazkov, urcena cislom snimku, resp. casom
    HRESULT ExtractFrame(LONG nFrameNum);
    HRESULT ExtractTime(LONG nMilisec);
    HRESULT ExtractFrameSequence(LONG nFrameFrom, LONG nFrameTo, LONG nFrameStep = 1);
    HRESULT ExtractTimeSequence(LONG nMilisecFrom, LONG nMilisecTo, LONG nTimeStep = 1);
    HRESULT ExtractAll();

	HRESULT ExtractFrameBMP(LONG nFrameNum, C4FBitmap* pResultBMP);

	virtual ~CAviExtractor();

	LPVOID ExtractFrameDIB(long nSampleNum) ;
	int GetAviLength(void);
};

#endif // !defined(AFX_AVIEXTRACTOR_H__685EA323_486F_11D5_A4EB_F3D749894D5B__INCLUDED_)
