//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				AVIStream2BMP.cpp
// Ucel suboru:			definicia triedy CAVIStream2BMP
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 20.4.2005
// Poznamka:			Extrakcia AVI do bitmap.
//						Autor: Juraj Hajek, 2000/2001
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "AVIStream2BMP.h"
#include <windows.h>
#include <wingdi.h> 
#include <vfw.h>
#include <mmsystem.h>


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


CAvi2Bmp::CAvi2Bmp()
	:CAviExtractor() 
{
   
}


CAvi2Bmp::CAvi2Bmp(CString &strVideoFilename)
	:CAviExtractor(strVideoFilename) 
{

}


CAvi2Bmp::~CAvi2Bmp()
{

}


// pomocna funkcia na ulozenie jednoducheho snimku
// param:	nPos - cislo snimku
//			lpData - zaciatok dat na zapisanie
//			nLength - ich dlzka
// return:	uspech 0, inak kod chyby
HRESULT CAvi2Bmp::WriteFrame(LONG nPos, LPBITMAPINFO lpBI, LPVOID lpData, LONG nLength)
{
    TCHAR				filename[_MAX_PATH];
    HMMIO				hmmio;
    BITMAPFILEHEADER	bfh;

    // otvornie suboru pre zapis
    wsprintf(filename, _T("%s%.5d.bmp"), m_strDefaultExportFilename, nPos);
    hmmio = mmioOpen(filename, NULL, MMIO_WRITE | MMIO_CREATE | OF_SHARE_EXCLUSIVE);

    if (!hmmio)
		return ResultFromScode(AVIERR_FILEOPEN);

    // fixneme niektore polia
    lpBI->bmiHeader.biCompression = BI_RGB;
    lpBI->bmiHeader.biSizeImage = (
		lpBI->bmiHeader.biWidth *
		lpBI->bmiHeader.biHeight *
		lpBI->bmiHeader.biBitCount) / 8;

    // Zapis hlavicky BMP-suboru
    bfh.bfType = 0x4d42;		// 'BM' 
    bfh.bfOffBits = sizeof(bfh) + lpBI->bmiHeader.biSize+40;	// posunutie dat
    bfh.bfSize = bfh.bfOffBits + lpBI->bmiHeader.biSizeImage;	// velkost suboru
    bfh.bfReserved1 = 0;
    bfh.bfReserved2 = 0;
		    
    // zapis hlavicku 
    if (mmioWrite(hmmio, (LPSTR) &bfh, sizeof(bfh)) != sizeof(bfh)) {
	    mmioClose(hmmio, 0);
	    return ResultFromScode(AVIERR_FILEWRITE);
    }

    // zapis hlavicku bitmapy
    if ((unsigned long)mmioWrite(hmmio, (LPSTR)lpBI, lpBI->bmiHeader.biSize) != lpBI->bmiHeader.biSize) {
	    mmioClose(hmmio, 0);
	    return ResultFromScode(AVIERR_FILEWRITE);
    }

    // zapis data
    if ((ULONG)mmioWrite(hmmio, (LPSTR)lpData, lpBI->bmiHeader.biSizeImage) != lpBI->bmiHeader.biSizeImage) {
	    mmioClose(hmmio, 0);
	    return ResultFromScode(AVIERR_FILEWRITE);
    }

    // flush-neme to, nech mame istotu, ze je to v subore 
    if (mmioFlush(hmmio, 0) != 0) {
	    mmioClose(hmmio, 0);
	    return ResultFromScode(AVIERR_FILEWRITE);
    }

    mmioClose(hmmio, 0);
    return 0;
}

