//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				FrameDlg.cpp
// Ucel suboru:			definicia triedy CFrameDlg
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 5.5.2005
//______________________________________________________________________________________________________


#include "stdafx.h"
#include "VideoSQC.h"
#include "FrameDlg.h"
#include <afxctl.h>
#include <Windows.h>
#include <Winuser.h>


IMPLEMENT_DYNAMIC(CFrameDlg, CDialog)
CFrameDlg::CFrameDlg(CWnd* pParent /*= NULL*/)
	: CDialog(CFrameDlg::IDD, pParent)
{
}


CFrameDlg::~CFrameDlg()
{
}


BOOL CFrameDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int nWidth = m_pFrame->GetBitmap()->m_pBmpInfoHdr->biWidth;

	int nTHeight = 30;
	int nHeight = m_pFrame->GetBitmap()->m_pBmpInfoHdr->biHeight + nTHeight;
	VERIFY(SetWindowPos(NULL, 0, 0, nWidth + 6, nHeight + 2, SWP_NOMOVE | SWP_NOOWNERZORDER));
	
	CString strText;
	strText.Format("Frame: %d,%d x %d", m_pFrame->GetPos(), nWidth, nHeight - nTHeight);
	SetWindowText(strText);
	
	return TRUE;
}


void CFrameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CFrameDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_LEFT_PELVIS, OnLeftPelvis)
	ON_COMMAND(ID_LEFT_FEMUR, OnLeftFemur)
	ON_COMMAND(ID_LEFT_LOWER, OnLeftLower)
	ON_COMMAND(ID_LEFT_FOOT, OnLeftFoot)
	ON_COMMAND(ID_LEFT_TALUS, OnLeftTalus)
	ON_COMMAND(ID_LEFT_TOE, OnLeftToe)
	ON_COMMAND(ID_CONTEXTMENU_NOTASSIGNED, OnNotAssigned)
END_MESSAGE_MAP()


void CFrameDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CPictureHolder*	pPicHolder = new CPictureHolder();
	CBitmap* bmp = m_pFrame->CreateBitmap();
	
	pPicHolder->CreateFromBitmap(bmp);
	CRect rect;
	GetClientRect(&rect);
	
	//vykreslenie zenseniny povodneho obrazku
	pPicHolder->Render(&dc, rect, rect);
	bmp->DeleteObject();
	
	//zapis cisla frameu
	m_pFrame->RenderLabels(this, 10);

	delete(pPicHolder);
}


void CFrameDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	CString strText;
	GetWindowText(strText);
	
	CRect rect;
	GetClientRect(&rect);

	int x = point.x * m_pFrame->GetBitmap()->m_pBmpInfoHdr->biWidth / rect.Width();
	int y = point.y * m_pFrame->GetBitmap()->m_pBmpInfoHdr->biHeight / rect.Height();
	strText.Format("Frame: %d,%d x %d, x: %d, y: %d",
		m_pFrame->GetPos(), m_pFrame->GetBitmap()->m_pBmpInfoHdr->biWidth,
		m_pFrame->GetBitmap()->m_pBmpInfoHdr->biHeight, x, y);
	SetWindowText(strText);
	
	switch (nFlags){
		case MK_LBUTTON:
			if (m_pFrame->LabelDrag(x, y)) Invalidate(FALSE);
			break;
		
		default:
			if (m_pFrame->LabelOver(x, y)) Invalidate(FALSE);
			break;
	}
	m_nMouseX = point.x;
	m_nMouseY = point.y;

	CDialog::OnMouseMove(nFlags, point);
}


void CFrameDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	switch (nFlags - 1){
		case MK_CONTROL:
			m_pFrame->LabelDel();
			Invalidate(FALSE);
			break;

		case MK_SHIFT:
			CRect rect;
			GetClientRect(&rect);
			
			int x = point.x * m_pFrame->GetBitmap()->m_pBmpInfoHdr->biWidth / rect.Width();
			int y = point.y * m_pFrame->GetBitmap()->m_pBmpInfoHdr->biHeight / rect.Height();
			
			m_pFrame->LabelAdd(x, y);
			Invalidate(FALSE);
			break;
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}


void CFrameDlg::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CRect rect;
	GetClientRect(&rect);

	int x = m_nMouseX * m_pFrame->GetBitmap()->m_pBmpInfoHdr->biWidth / rect.Width();
	int y = m_nMouseY * m_pFrame->GetBitmap()->m_pBmpInfoHdr->biHeight / rect.Height();
	int nJointId = m_pFrame->LabelGetJointID();
	
	TRACE("JID: %d", nJointId);
	if (nJointId == 0) return;
	
	CMenu menu;
    menu.LoadMenu(IDR_FRAME_CTXMENU);
	CMenu*	pSubmenu = menu.GetSubMenu(0);

	if (nJointId == 1)
		pSubmenu->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
	else
		pSubmenu->CheckMenuItem(nJointId, MF_BYPOSITION | MF_CHECKED);
	
	pSubmenu->TrackPopupMenu(TPM_CENTERALIGN | TPM_LEFTBUTTON, point.x, point.y, this);
}


void CFrameDlg::OnLeftPelvis()
{
	m_pFrame->LabelSetJoint(2);
	Invalidate(FALSE);
}


void CFrameDlg::OnLeftFemur()
{
	m_pFrame->LabelSetJoint(3);
	Invalidate(FALSE);
}


void CFrameDlg::OnLeftLower()
{
	m_pFrame->LabelSetJoint(4);
	Invalidate(FALSE);
}


void CFrameDlg::OnLeftFoot()
{
	m_pFrame->LabelSetJoint(5);
	Invalidate(FALSE);
}


void CFrameDlg::OnLeftTalus()
{
	m_pFrame->LabelSetJoint(6);
	Invalidate(FALSE);
}


void CFrameDlg::OnLeftToe()
{
	m_pFrame->LabelSetJoint(7);
}


void CFrameDlg::OnNotAssigned()
{
	m_pFrame->LabelSetJoint(1);
}
