//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				SequenceHolder.h
// Ucel suboru:			deklaracia triedy CSequenceHolder
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 20.4.2005
//______________________________________________________________________________________________________


#ifndef __sqcholder_h__
#define __sqcholder_h__

#include "FrameSequence.h"
#include "Frame.h"
#include "VideoSQCDlg.h"

#pragma once

class CVideoSQCDlg;

//trieda sliaca na manipulciu so sekvenciami
class CSequenceHolder
{
private:
	//pole sekvencii
	CFrameSequence*	m_pSeq[SEQ_COUNT];
	//odkaz na hlavny dialog
	CVideoSQCDlg*	m_pDlg;
	//pocet nacitanych sekvencii
	int m_nNumSeq;

public:
	CSequenceHolder(CVideoSQCDlg* pDlg);
	~CSequenceHolder(void);
	//pocet nacitanych videi
	int GetSeqCount();
	//inicializacia sekvencie
	//vstup1: cislo inicializovanej sekvencie
	//vstup2: pole resource komponentov
	void InitSeq(int nSeqID, int* pCtrlIDs);
	//nastavenie video streamu pre konkretnu sekvenciu
	//vstup1: cislo sekvencie
	//vstup2: meno k AVI streamu
	HRESULT SetStream(int nSeqID, CString strFileName);
	//prekreslenie  konkretnej sekvecncie 
	HRESULT Redraw(int nSeqID);
	//presun na dalsi snimok v konkretnej sekvecncii
	HRESULT Next(int nSeqID);
	//presun na predosli snimok v konkretnej sekvecncii
	HRESULT Prev(int nSeqID);
	//prehravanie konkretnej sekvecncie
	HRESULT Play(int nSeqID);
	//nastavenie na prvy snimok v ramci konkretnej sekvecncie
	HRESULT Reset(int nSeqID);
	//presun na poziciu
	//vstup1: cislo sekvencie
	//vstup2:pozicia v ramci snimku
	HRESULT GoToPos(int nSeqID, int nPos);
	//callback funkcia pre prehravanie videa
	//pri vyvolani sa presunie v sekvencii na dalsiu snimku
	HRESULT OnTimer(int nSeqID);
	//synchronizacia
	HRESULT FindSamples();
	//spojenie prehravanie sekvencii
	HRESULT Lock();
	//odomknutie prehravanie sekvencii
	HRESULT Unlock(void);
	//vyvolanie segmentacie vsetkychych sekvencii
	HRESULT Segmentation(void);
	//vrati slider resource ID pre konkrenu sekvenciu
	CSliderCtrl* GetSlider(CFrameSequence* pSeq);
	//vyvolanie prekreslenia konkretnej sekvencie
	void Invalidate(int nSeqID);
	//zobrazenie snimku zo sekvencie
	//vstup1: cislo sekvencie
	//vstup2: cislo snimku
	void Show(int nSeqID, int nFrameID);
	//korespodencia
	HRESULT JointsSort(void);
	//ulozenie snimok v zvolenom formate na zvolene miesto
	HRESULT JointsSave(CString filename, int format);
	//nacitanie z formatu bbs
	HRESULT JointsLoad(const char* filename);
};

#endif //__sqcholder_h__
