//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				VideoExtractor.h
// Ucel suboru:			deklaracia triedy CVideoExtractor
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 20.4.2005
// Poznamka:			Abstraktna trieda, implementujuca pristup
//						k video suborom, za ucelom extrakcie obrazkov.
//						Nie je zavisla na vstupnom ani vystupnom formate.
//						Autor: Juraj Hajek, 2000/2001
//______________________________________________________________________________________________________


#if !defined(AFX_VIDEOEXTRACTOR_H__685EA321_486F_11D5_A4EB_F3D749894D5B__INCLUDED_)
#define AFX_VIDEOEXTRACTOR_H__685EA321_486F_11D5_A4EB_F3D749894D5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CVideoExtractor : public CObject
{
protected:
	CString m_strDefaultExportFilename;

public:
	// otvorenie a inicializacia video streamu
    virtual HRESULT OpenFile(CString &strVideoFilename) = 0;
    // uzavretie a uvolnenie video streamu
    virtual HRESULT CloseFile() = 0;

    // standarny prefix ukladanych obrazkov
    HRESULT SetDefaultExportName(CString &strImageFilename);

    // extrakcia do obrazkov, urcena cislom snimku, resp. casom
    virtual HRESULT ExtractFrame(LONG nFrameNum) = 0;
    virtual HRESULT ExtractTime(LONG nMilisec) = 0;
    virtual HRESULT ExtractFrameSequence
	  (LONG nFrameFrom, LONG nFrameTo, LONG nFrameStep = 1) = 0;
    virtual HRESULT ExtractTimeSequence
	  (LONG nMilisecFrom, LONG nMilisecTo, LONG nTimeStep = 1) = 0;
    virtual HRESULT ExtractAll() = 0;

	CVideoExtractor();
	virtual ~CVideoExtractor();
};

#endif // !defined(AFX_VIDEOEXTRACTOR_H__685EA321_486F_11D5_A4EB_F3D749894D5B__INCLUDED_)
