//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				VideoSQCDlg.cpp
// Ucel suboru:			definicia triedy CVideoSQCDlg
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 12.05.2005
//______________________________________________________________________________________________________


#include "stdafx.h"
#include <afxctl.h>
#include "VideoSQCDlg.h"
#include "VideoSQC.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
};


CAboutDlg::CAboutDlg()
	: CDialog(CAboutDlg::IDD)
{
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


CVideoSQCDlg::CVideoSQCDlg(CWnd* pParent /*= NULL*/)
	: CDialog(CVideoSQCDlg::IDD, pParent)
	, m_pSeq(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CVideoSQCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CVideoSQCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DRAWITEM()
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SQC1_NEXT, OnBnClickedSqc1Next)
	ON_BN_CLICKED(IDC_SQC1_PREV, OnBnClickedSqc1Prev)
	ON_BN_CLICKED(IDC_SEQ1_GO, OnBnClickedSeq1Go)
	ON_BN_CLICKED(IDC_SQC2_NEXT, OnBnClickedSqc2Next)
	ON_BN_CLICKED(IDC_SQC2_PREV, OnBnClickedSqc2Prev)
	ON_BN_CLICKED(IDC_SEQ2_GO, OnBnClickedSeq2Go)
	ON_BN_CLICKED(IDC_SEQ1_PLAY, OnBnClickedSeq1Play)
	ON_BN_CLICKED(IDC_SEQ2_PLAY, OnBnClickedSeq2Play)
	ON_COMMAND(ID_FILE_STREAM1_OPEN, OnStream1Open)
	ON_COMMAND(ID_FILE_STREAM2_OPEN, OnStream2Open)
	ON_COMMAND(ID_FILE_STREAM1_RESET, OnStream1Reset)
	ON_COMMAND(ID_FILE_STREAM2_RESET, OnStream2Reset)
	ON_COMMAND(ID_FILE_STARTANALYSER, OnFileStartAnalyser)
	ON_COMMAND(ID_FILE_STARTBLUEBONE, OnFileStartBluebone2)
	ON_COMMAND(ID_VIEW_VIDEO, OnViewVideo)
	ON_COMMAND(ID_VIEW_HISTOGRAM, OnViewHistogram)
	ON_COMMAND(ID_TOOLS_SYNC_FINDSAMPLES, OnSyncFindSamples)
	ON_COMMAND(ID_TOOLS_SYNC_LOCK, OnSynchronizeLock)
	ON_COMMAND(ID_TOOLS_SYNC_UNLOCK, OnSynchronizeUnlock)
	ON_COMMAND(ID_TOOLS_JOINTS_SEGMENT, OnToolsSegment)
	ON_COMMAND(ID_TOOLS_JOINTS_SORT, OnToolsSortJoints)
	ON_COMMAND(ID_TOOLS_JOINTS_SAVE, OnToolsSaveJoints)
	ON_COMMAND(ID_TOOLS_JOINTS_LOAD, OnToolsLoadJoints)
	ON_STN_CLICKED(IDC_SEQ1_FR1, OnStnClickedSeq1Fr1)
	ON_STN_CLICKED(IDC_SEQ1_FR2, OnStnClickedSeq1Fr2)
	ON_STN_CLICKED(IDC_SEQ1_FR3, OnStnClickedSeq1Fr3)
	ON_STN_CLICKED(IDC_SEQ1_FR4, OnStnClickedSeq1Fr4)
	ON_STN_CLICKED(IDC_SEQ2_FR1, OnStnClickedSeq2Fr1)
	ON_STN_CLICKED(IDC_SEQ2_FR2, OnStnClickedSeq2Fr2)
	ON_STN_CLICKED(IDC_SEQ2_FR3, OnStnClickedSeq2Fr3)
	ON_STN_CLICKED(IDC_SEQ2_FR4, OnStnClickedSeq2Fr4)
END_MESSAGE_MAP()


BOOL CVideoSQCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_pSeq = new CSequenceHolder(this);
	
	int SQC1_IDS[12];
	SQC1_IDS[0] = IDC_SEQ1_FR1;		SQC1_IDS[1] = IDC_SEQ1_FR2;
	SQC1_IDS[2] = IDC_SEQ1_FR3;		SQC1_IDS[3] = IDC_SEQ1_FR4;
	SQC1_IDS[4] = IDC_SEQ1_FRN1;	SQC1_IDS[5] = IDC_SEQ1_FRN2;
	SQC1_IDS[6] = IDC_SEQ1_FRN3;	SQC1_IDS[7] = IDC_SEQ1_FRN4;
	SQC1_IDS[8] = IDC_SQC1;			SQC1_IDS[9] = IDC_SEQ1_SLIDER;
	SQC1_IDS[10] = IDC_SEQ1_PLAY;
	m_pSeq->InitSeq(1, SQC1_IDS);

	int SQC2_IDS[12] ;
	SQC2_IDS[0] = IDC_SEQ2_FR1;		SQC2_IDS[1] = IDC_SEQ2_FR2;
	SQC2_IDS[2] = IDC_SEQ2_FR3;		SQC2_IDS[3] = IDC_SEQ2_FR4;
	SQC2_IDS[4] = IDC_SEQ2_FRN1;	SQC2_IDS[5] = IDC_SEQ2_FRN2;
	SQC2_IDS[6] = IDC_SEQ2_FRN3;	SQC2_IDS[7] = IDC_SEQ2_FRN4;
	SQC2_IDS[8] = IDC_SQC2;			SQC2_IDS[9] = IDC_SEQ2_SLIDER;
	SQC2_IDS[10] = IDC_SEQ2_PLAY;
	m_pSeq->InitSeq(2, SQC2_IDS);
	
	// dialogLoaded 
	m_bLocked = false;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CVideoSQCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}


// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CVideoSQCDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}


// The system calls this function to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CVideoSQCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CVideoSQCDlg::OnStream1Open()
{
	OpenStreamDlg(1);
}


void CVideoSQCDlg::OnStream2Open()
{
	OpenStreamDlg(2);
}


void CVideoSQCDlg::OpenStreamDlg(int nSqcID)
{
	char szFilters[] = "AVI Files (*.avi)|*.avi||";
	// vytvorenie file dialogu
	CFileDialog dlgOpenFile(TRUE, "avi", "*.avi", OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);
	// otvorime dialog ak kliknem na ok navratova hodnota .DoModal bude IDOK
	if (dlgOpenFile.DoModal() == IDOK)
		m_pSeq->SetStream(nSqcID, dlgOpenFile.GetPathName());
}


void CVideoSQCDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	if (m_pSeq)
		m_pSeq->Redraw(nIDCtl);
	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}


void CVideoSQCDlg::PictureRedraw(CFrame* pFrame)
{
	CWnd*	pPicture = GetDlgItem(pFrame->GetPicCtrl());
	CDC*	pDC = pPicture->GetDC();
	CPictureHolder* pPicHolder = new CPictureHolder();

	CMenu* pMenu = GetMenu();
	CMenu* pSubmenu = pMenu->GetSubMenu(1);

	UINT nState = pSubmenu->GetMenuState(ID_VIEW_VIDEO, MF_BYCOMMAND);
	ASSERT(nState != 0xFFFFFFFF);
	CBitmap* pBmp;
	if (nState & MF_CHECKED)
		pBmp = pFrame->CreateBitmap();
	else
		pBmp = pFrame->GetBitmap()->m_pHisto->GetHistoBMP();

	pPicHolder->CreateFromBitmap(pBmp);
	CRect rect;
	pPicture->GetClientRect(&rect);
	
	// vykreslenie zmenseniny povodneho obrazku
	pPicHolder->Render(pDC, rect, rect);
	pBmp->DeleteObject();
	// zapis cisla frameu
	CString text;
	text.Format("F: %d", pFrame->GetPos());
	GetDlgItem(pFrame->GetFrNumCtrl())->SetWindowText(text);
	pFrame->RenderLabels(pPicture, 5);
	
	delete pPicHolder;
}


void CVideoSQCDlg::OnBnClickedSqc1Next()
{
	m_pSeq->Next(1);
	if (m_bLocked)
		m_pSeq->Next(2);
}


void CVideoSQCDlg::OnBnClickedSqc2Next()
{
	m_pSeq->Next(2);
	if (m_bLocked)
		m_pSeq->Next(1);
}


void CVideoSQCDlg::OnBnClickedSqc1Prev()
{
	m_pSeq->Prev(1);
	if (m_bLocked)
		m_pSeq->Prev(2);
}


void CVideoSQCDlg::OnBnClickedSqc2Prev()
{
	m_pSeq->Prev(2);
	if (m_bLocked)
		m_pSeq->Prev(1);
}


void CVideoSQCDlg::OnBnClickedSeq1Go()
{
	CString str;
	GetDlgItem(IDC_SEQ1_FRN)->GetWindowText(str);
	int nPos = atoi((LPCTSTR)str);
	m_pSeq->GoToPos(1, nPos);
	if (m_bLocked)
		m_pSeq->GoToPos(2, nPos);
}


void CVideoSQCDlg::OnBnClickedSeq2Go()
{
	CString str;
	GetDlgItem(IDC_SEQ2_FRN)->GetWindowText(str);
	int nPos = atoi((LPCTSTR)str);
	m_pSeq->GoToPos(2, nPos);
	if (m_bLocked)
		m_pSeq->GoToPos(1, nPos);
}


void CVideoSQCDlg::OnStream1Reset()
{
	m_pSeq->Reset(1);
	if (m_bLocked)
		m_pSeq->Reset(2);
}


void CVideoSQCDlg::OnStream2Reset()
{
	m_pSeq->Reset(2);
	if (m_bLocked)
		m_pSeq->Reset(1);
}


void CVideoSQCDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	CSliderCtrl* pSldr1 = (CSliderCtrl*)GetDlgItem(IDC_SEQ1_SLIDER);
	CSliderCtrl* pSldr2 = (CSliderCtrl*)GetDlgItem(IDC_SEQ2_SLIDER);
	
	if ((CWnd*)pSldr1 == (CWnd*)pScrollBar) {
		m_pSeq->GoToPos(1, pSldr1->GetPos());
		if (m_bLocked)
			m_pSeq->GoToPos(2, pSldr1->GetPos());
	}
	if ((CWnd*)pSldr2 == (CWnd*)pScrollBar) {
		m_pSeq->GoToPos(2, pSldr2->GetPos());
		if (m_bLocked)
			m_pSeq->GoToPos(1, pSldr2->GetPos());
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CVideoSQCDlg::OnTimer(UINT nIDEvent)
{
	m_pSeq->OnTimer(nIDEvent);
	CDialog::OnTimer(nIDEvent);
}


void CVideoSQCDlg::OnBnClickedSeq1Play()
{
	m_pSeq->Play(1);
	if (m_bLocked)
		m_pSeq->Play(2);
}


void CVideoSQCDlg::OnBnClickedSeq2Play()
{
	m_pSeq->Play(2);
	if (m_bLocked)
		m_pSeq->Play(1);
}


void CVideoSQCDlg::OnViewVideo()
{
	CMenu* pMenu = GetMenu()->GetSubMenu(1);
	// Check the state of the "Test" menu item. Check the menu item
	// if it is currently unchecked. Otherwise, uncheck the menu item
	// if it is not currently m_bChecked.
	UINT nState = pMenu->GetMenuState(ID_VIEW_VIDEO, MF_BYCOMMAND);
	ASSERT(nState != 0xFFFFFFFF);
	pMenu->CheckMenuItem(ID_VIEW_HISTOGRAM, MF_UNCHECKED | MF_BYCOMMAND);
	pMenu->CheckMenuItem(ID_VIEW_VIDEO, MF_CHECKED | MF_BYCOMMAND);
	
	Invalidate(0);	
}


void CVideoSQCDlg::OnViewHistogram()
{
	CMenu* pMenu = GetMenu()->GetSubMenu(1);
	// Check the state of the "Test" menu item. Check the menu item
	// if it is currently unchecked. Otherwise, uncheck the menu item
	// if it is not currently m_bChecked.
	UINT nState = pMenu->GetMenuState(ID_VIEW_HISTOGRAM, MF_BYCOMMAND);
	ASSERT(nState != 0xFFFFFFFF);
	pMenu->CheckMenuItem(ID_VIEW_VIDEO, MF_UNCHECKED | MF_BYCOMMAND);
	pMenu->CheckMenuItem(ID_VIEW_HISTOGRAM, MF_CHECKED | MF_BYCOMMAND);
	
	Invalidate(0);
}


void CVideoSQCDlg::OnSyncFindSamples()
{
	m_pSeq->FindSamples();
}


void CVideoSQCDlg::OnSynchronizeLock()
{
	m_pSeq->Lock();
	m_bLocked = true;
}


void CVideoSQCDlg::OnSynchronizeUnlock()
{
	m_pSeq->Unlock();
	m_bLocked = false;
}


void CVideoSQCDlg::OnToolsSegment()
{
	m_pSeq->Segmentation();
}


void CVideoSQCDlg::OnStnClickedSeq1Fr1()
{
	m_pSeq->Show(1,0);
}


void CVideoSQCDlg::OnStnClickedSeq1Fr2()
{
	m_pSeq->Show(1,1);
}


void CVideoSQCDlg::OnStnClickedSeq1Fr3()
{
	m_pSeq->Show(1,2);
}


void CVideoSQCDlg::OnStnClickedSeq1Fr4()
{
	m_pSeq->Show(1,3);
}


void CVideoSQCDlg::OnStnClickedSeq2Fr1()
{
	m_pSeq->Show(2,0);
}


void CVideoSQCDlg::OnStnClickedSeq2Fr2()
{
	m_pSeq->Show(2,1);
}


void CVideoSQCDlg::OnStnClickedSeq2Fr3()
{
	m_pSeq->Show(2,2);
}


void CVideoSQCDlg::OnStnClickedSeq2Fr4()
{
	m_pSeq->Show(2,3);
}


void CVideoSQCDlg::OnToolsSortJoints()
{
	m_pSeq->JointsSort();
}


void CVideoSQCDlg::OnToolsSaveJoints()
{
	static char acFilter[] = "BlueBone Animation files (*.bbs)|*.bbs||";
	CFileDialog dlgSaveFile(FALSE, "bbs", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, acFilter);
	if (dlgSaveFile.DoModal() == IDOK)
		m_pSeq->JointsSave(dlgSaveFile.GetFileName(),BBS_FORMAT);
}


void CVideoSQCDlg::OnToolsLoadJoints()
{
	static char acFilter[] = "BlueBone Animation files (*.bbs)|*.bbs||";
	CFileDialog dlgSaveFile(FALSE, "bbs", NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, acFilter);
	if (dlgSaveFile.DoModal() == IDOK)
		m_pSeq->JointsLoad(dlgSaveFile.GetFileName());
}


CString GetFolderPath()
{
	CString strFilePath, strFolderPath;
	// Get program file path
	TCHAR lpFileName[MAX_PATH + 1];
	GetModuleFileName(NULL, lpFileName, MAX_PATH);
	strFilePath = lpFileName;
	//Get program folder
	int nLastIndex = strFilePath.ReverseFind('\\');
	if (nLastIndex != -1)
		strFolderPath = strFilePath.Left(nLastIndex + 1);
	else
		strFolderPath = _T("\\");

	return strFolderPath;
}

void CVideoSQCDlg::OnFileStartAnalyser()
{
	//mozeme spustat analyzator v dvoch modoch 
	//ako jedna 3d chvodza alebo dve 2D chvodze ak chceme
	CString params;
	params.Format("%d", m_pSeq->GetSeqCount());
	if(m_pSeq->GetSeqCount() == 0){
		AfxMessageBox("No video loaded!");
		return;
	}
	int choice;
	if(m_pSeq->GetSeqCount() > 1) choice = AfxMessageBox("Export one file?\nFor one file (3D N/A) press YES. \nFor two files (2D) press NO", MB_YESNO, 0);
	m_pSeq->JointsSave(GetFolderPath() + _T("data_an\\videosqc"), BBD_FORMAT);
	if(choice == IDYES)
	//tu by malo byt generovanie 3D suradnic
		::ShellExecute(NULL, "open", GetFolderPath() + _T("Analyser.exe"),
			_T("1"), NULL, SW_SHOWDEFAULT);
	if(choice == IDNO)
		::ShellExecute(NULL, "open", GetFolderPath() + _T("Analyser.exe"),
			params, NULL, SW_SHOWDEFAULT);
}


void CVideoSQCDlg::OnFileStartBluebone2()
{
	::ShellExecute(NULL, "open", GetFolderPath() + _T("BlueBone2.exe"), NULL, NULL, SW_SHOWDEFAULT);
}

