//______________________________________________________________________________________________________
// Projekt:				Vizualizacia a analyza chodze cloveka
//						Timovy projekt 2004/5 - tim 4F (Four Fit Feet of FIIT)
//						FIIT STU, Bratislava
//------------------------------------------------------------------------------------------------------
// Subor:				VideoSQCDlg.h
// Ucel suboru:			deklaracia triedy CVideoSQCDlg
// Datum vytvorenia:	5.4.2005
// Vytvoril:			Peter Argalas
// Naposledy zmenil:	Lucenic / 7.5.2005
//______________________________________________________________________________________________________


#ifndef __VideoSQCDlg_h__
#define __VideoSQCDlg_h__

#include "VideoSQC.h"
#include "FrameSequence.h"
#include "SequenceHolder.h"
#include "afxcmn.h"

#pragma once

class CSequenceHolder;


class CVideoSQCDlg : public CDialog
{
public:
	CVideoSQCDlg(CWnd* pParent = NULL);

	enum { IDD = IDD_VIDEOSQC_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	//id timerov na prehravanie videa
	UINT_PTR			m_nTimers[10];
	//odkaz na objekt cez ktory sa pristuje k vsetkym sekvenciam
	CSequenceHolder*	m_pSeq;
	//flag udavajuci ci je spojene prehravanie sekvencii
	bool				m_bLocked;
	
	void OpenStreamDlg(int nSqcID);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnTimer(UINT nIDEvent);

	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	//vykreslovacia funkcia zobrazi snimku do prislusneho pola
	void PictureRedraw(CFrame* pFrame);
	//ovaldanie sekvencii
	afx_msg void OnBnClickedSqc1Next();
	afx_msg void OnBnClickedSqc1Prev();
	afx_msg void OnBnClickedSeq1Go();
	afx_msg void OnBnClickedSqc2Next();
	afx_msg void OnBnClickedSqc2Prev();
	afx_msg void OnBnClickedSeq2Go();
	afx_msg void OnBnClickedSeq1Play();
	afx_msg void OnBnClickedSeq2Play();


	// otvorenie a reset sekvencii
	afx_msg void OnStream1Open();
	afx_msg void OnStream2Open();
	afx_msg void OnStream1Reset();
	afx_msg void OnStream2Reset();
	//orvorenie aplikacie Analyser
	afx_msg void OnFileStartAnalyser();
	//orvorenie aplikacie BB2
	afx_msg void OnFileStartBluebone2();
	//zobraz snimky ako obrazky
	afx_msg void OnViewVideo();
	//zobraz snimky ako histogram
	afx_msg void OnViewHistogram();
	//syncronizacia sekvencii
	afx_msg void OnSyncFindSamples();
	//spojenie prehravannia sekvencii
	afx_msg void OnSynchronizeLock();
	//odomknutie prehravania sekvencii
	afx_msg void OnSynchronizeUnlock();
	//segmentacia sekvencii
	afx_msg void OnToolsSegment();
	//otvaranie edit dialogu pre snimky
	afx_msg void OnStnClickedSeq1Fr1();
	afx_msg void OnStnClickedSeq1Fr2();
	afx_msg void OnStnClickedSeq1Fr3();
	afx_msg void OnStnClickedSeq1Fr4();
	afx_msg void OnStnClickedSeq2Fr1();
	afx_msg void OnStnClickedSeq2Fr2();
	afx_msg void OnStnClickedSeq2Fr3();
	afx_msg void OnStnClickedSeq2Fr4();
	//zistovanie korespodencie
	afx_msg void OnToolsSortJoints();
	//ulozenie pozicii a korespodencie znaciek
	afx_msg void OnToolsSaveJoints();
	//nacitanie pozicii a korespodencie znaciek
	afx_msg void OnToolsLoadJoints();
};

#endif //__VideoSQCDlg_h__
